/**
 * Esimerkki dynaamisesta taulukosta Java 1.5:n geneerisyytt
 * ja "autoboxingia" kytten.
 * @author Vesa Lappalainen
 * @version 1.0, 02.03.2002
 * @version 1.1, 01.03.2005
 * @param <TYPE> Tyyppi jota talletetaan
 */

public class TaulukkoGen<TYPE> {
  public static class TaulukkoTaysiException extends Error {
    TaulukkoTaysiException(String viesti) { super(viesti); }
  }

  private TYPE alkiot[];
  private int lkm;

  public TaulukkoGen() {
    this(10);
  }

  public TaulukkoGen(int koko) {
    alkiot = (TYPE [])new Object[koko];
    // alkiot = new TYPE[koko];
  }

  public void lisaa(TYPE i) throws TaulukkoTaysiException {
    if ( lkm >= alkiot.length ) throw new TaulukkoTaysiException("Tila loppu");
    alkiot[lkm++] = i;
  }

  public String toString() {
    StringBuffer s = new StringBuffer("");
    for (int i=0; i<lkm; i++)
      s.append(" " + alkiot[i]);
    return s.toString();
  }

  public void set(int i, TYPE alkio) throws IndexOutOfBoundsException {
    if ( ( i < 0 ) || ( lkm <= i ) ) throw new IndexOutOfBoundsException("i = " + i);
    alkiot[i] = alkio;
  }

  public TYPE get(int i) throws IndexOutOfBoundsException {
    if ( ( i < 0 ) || ( lkm <= i ) ) throw new IndexOutOfBoundsException("i = " + i);
    return alkiot[i];
  }

  public static void main(String[] args) {

    TaulukkoGen<Integer> luvut = new TaulukkoGen<Integer>();


    Integer oma = new Integer(7);
    try {
      luvut.lisaa(0); luvut.lisaa(2);
      luvut.lisaa(99);  // Tekee oikeasti luvut.lisaa(new Integer(99));
      luvut.lisaa(oma);
    } catch ( TaulukkoTaysiException e ) {
      System.out.println("Virhe: " + e.getMessage());
    }
    System.out.println(luvut);
    luvut.set(1,4);
    luvut.set(3,88);
    oma = luvut.get(3);
    System.out.println(luvut);
    int luku = luvut.get(2);  // oik: luku = (Integer)(luvut.get(2)).intValue();
    System.out.println("Paikassa 2 on " + luku);
    try {
     // luvut.set(21, 4);
    }
    catch (IndexOutOfBoundsException e) {
      System.out.println("Virhe: " + e.getMessage());
    }
    
    
    TaulukkoGen<String> sanat = new TaulukkoGen<String>(); /// VL: ei voi olla <int> :-(
    sanat.lisaa("kissa");
    sanat.lisaa("koira");
    sanat.lisaa("kana");
    
    System.out.println(sanat.toString());
    
  }
}
