
import fi.jyu.mit.ohj2.Tiedosto;
import java.util.Iterator;
import java.util.Collection;
import java.io.OutputStream;
import java.io.PrintStream;

/**
 * Esimerkki dynaamisesta taulukosta
 * @author Vesa Lappalainen
 * @version 1.0, 02.03.2002
 */

public class TaulukkoIter implements Iterable<Integer>{
  public class TaulukkoIterTaysiException extends Exception {
    TaulukkoIterTaysiException(String viesti) { super(viesti); }
  }

  private Integer alkiot[];
  private int lkm;

  public TaulukkoIter() {
    alkiot = new Integer[4];
    lkm = 0;
  }

  public TaulukkoIter(int koko) {
    alkiot = new Integer[koko];
    lkm = 0;
  }

  public void lisaa(Integer i) throws TaulukkoIterTaysiException {
    if ( lkm >= alkiot.length )  throw new TaulukkoIterTaysiException("Tila loppu");
    alkiot[lkm] = i;
    lkm++;
  }

  public String toString() {
    StringBuffer s = new StringBuffer("");
    for (int i=0; i<lkm; i++)
      s.append(" " + alkiot[i]);
    return s.toString();
  }

  public void set(int i, Integer luku) throws IndexOutOfBoundsException {
    //if ( ( i < 0 ) || ( lkm <= i ) ) throw new IndexOutOfBoundsException("i = " + i);
    alkiot[i] = luku;
  }

  public Integer get(int i) throws IndexOutOfBoundsException {
    if ( ( i < 0 ) || ( lkm <= i ) ) throw new IndexOutOfBoundsException("i = " + i);
    return alkiot[i];
  }

  public static void tulosta(OutputStream os,  TaulukkoIter luvut) {
    PrintStream out = Tiedosto.getPrintStream(os);
    for (Iterator i = luvut.iterator(); i.hasNext(); ) {
      int luku = ((Integer)i.next()).intValue();
      out.print(luku + " ");
    }
    out.println();
  }


  public class Iter implements Iterator {
    int kohdalla;

    public Iter() {
      kohdalla = -1;
    }

    public boolean hasNext() {
      return kohdalla < lkm-1;
    }

    public Object next() {
      return alkiot[++kohdalla];
    }

    public void remove() {

    }

  }

  public Iterator iterator() {
    return new Iter();
  }

  public static void main(String[] args) {
   /*
    Integer i1 = new Integer(5);
    Integer i2 = new Integer(6);
    System.out.println(i1);
    i2 = new Integer(4);
    i2 = 4;
    int i3 = i2.intValue();
    i2 = i1 * i2;
    i2 = new Integer(i1.intValue() + i2.intValue());
    System.out.println(i2);

 if ( true ) return;
  */
    TaulukkoIter luvut = new TaulukkoIter(100);
    try {
      luvut.lisaa(0); // luvut.lisaa(new Integer(0));
      luvut.lisaa(2);
      luvut.lisaa(99);
    } catch ( TaulukkoIterTaysiException e ) {
      System.out.println("Virhe: " + e.getMessage());
    }
    System.out.println(luvut);
    luvut.set(1,4); // luvut.set(1, new Integer(4));
    System.out.println(luvut);
    int luku = luvut.get(2);
    System.out.println("Paikassa 2 on " + luku);

    tulosta(System.out,luvut);

    try {
      luvut.set(21, 4);
    }
    catch (IndexOutOfBoundsException e) {
      System.out.println("Virhe: " + e.getMessage());
    }
    
    for (int i:luvut) System.out.print(i + " ");
    System.out.println();
  }
}
