
/**
 * Esimerkill demonstroidaan kahta rinnakkaista siett ja lukituksia.
 * @author vesal
 * @version 07.05.2008
 */
public class ThreadTesti {

  /**
   * Luokalla listn laskurin arvoa ja tulostetaan laskurin arvo.
   */	
  public static class Incrementer {
    int n;

    /**
     * Tulostetaan laskurin merkkijono ja laskurin arvo.
     * Samaan metodiin ei saa tulla toinen sie suorituksen aikana. 
     * @param s tulostettava jono
     * @param t aika joka odotetaan ennen aliohjelmasta poistumista
     * @return onko sikeen syyt jatkua (true) vai ei.
     */
    public synchronized boolean print(String s, int t) {
//    public boolean print(String s, int t) {
      System.out.println(s + ": " + n);
      n++;
      try { Thread.sleep(t); }
      catch (InterruptedException ex) {
        System.out.println("Pysytetty! " + s);
        return false;
      }
      return true;
    }
  }

  
  /**
   * Sie-luokka joka tulostaa 1 sekunnin vlein
   */
  public static class Thread1 extends Thread {
    private Incrementer inc;
    Thread1(Incrementer inc) { this.inc = inc; }

    /**
     * Tulostetaan 1 sekunnin vlein.
     */
    public void run() {
      while ( !isInterrupted() ) {
        if ( !inc.print("1",1000) ) break;
      }
    }
  }

  
  /**
   * Sie-luokka joka tulostaa 2 mahdollisimman nopeasti
   */
  public static class Thread2 extends Thread {
    private Incrementer inc;
    Thread2(Incrementer inc) { this.inc = inc; }

    /**
     * Tulostetaan 2 mahdollisimman nopeasti
     */
    public void run() {
      while ( !isInterrupted() ) {
        if ( !inc.print("2",0) ) break;
      }
    }
  }


  /**
   * Kynnistetn kaksi siett josita toinen tulostaa
   * sekunnin vlein 1 ja toinen mahdollisimman nopeasti 2.
   * @param args
   */
  public static void main(String[] args) {
    Incrementer inc = new Incrementer();
    Thread1 t1 = new Thread1(inc);
    t1.start();
    Thread2 t2 = new Thread2(inc);
    t2.start();
    //t1.start();
    try { Thread.sleep(5000); }
    catch (InterruptedException ex) {  }
    t1.interrupt();
    try { Thread.sleep(50); }
    catch (InterruptedException ex) {  }
    t2.interrupt();
  }
}
