package huone;

/**
 * Vastukset Huone-tehtvn.
 * @author Vesa Lappalainen
 * @version 1.0, 25.02.2003
 * @version 1.1, 21.02.2011
 */
public class Huone2 {

    /**
     * muotoile("olohuone",12,24,1) palauttaa rivin muodossa:<br>
     * olohuone    12 m2 24 m3  1 kaappia
     * @param teksti teksti joka tulostuu rivin alkuun
     * @param ala tulostettava pinta-ala
     * @param tilavuus tulostettava tilavuus
     * @param kaappeja tulostettava kaappien lukumr
     * @return tiedot muotoiltuna
     */
    public static String muotoile(String teksti,double ala, double tilavuus, int kaappeja) {
        return String.format("%-10s %2.0f m2 %2.0f m3 %2d kaappia",teksti,ala,tilavuus,kaappeja);
    }

  private String nimi;
  private double pit,lev,kork;
  private int kaappeja;
  Huone2(String n, double p, double l, double k, int kaap)
      { nimi=n; pit=p; lev=l; kork=k; kaappeja=kaap; }
  public double ala()                { return pit*lev;                              }
  public double tilavuus()           { return ala()*kork;                           }
  public int    getKaappeja()        { return kaappeja;                             }
  public void   kaapitPois()         { kaappeja = 0;                                }
  public void   lisaaKaappeja()      { kaappeja++;                                  }
  public String toString()           { return muotoile(nimi,ala(),tilavuus(), getKaappeja()); }

  public static void main(String[] args)  {
    Huone2 olohuone = new Huone2("olohuone",3,4,2,0);
    System.out.println(olohuone);
    olohuone.lisaaKaappeja();
    System.out.println(olohuone);
  }
}
