package huone;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

/**
 * Testataan Huone-luokan toimintaa
 * @author Vesa Lappalainen 
 * @version 21.2.2007
 */
public class HuoneTest {

	private Huone huone;
	
	/**
	 * Luodaan huone 
	 */
	@Before
	public void setUp() {
	  huone = new Huone("olohuone",3,4,2,0);
	}

	/**
	 * Testataan alan laskemista.
	 */
	@Test
	public void testAla() {
		assertEquals("Ala: ", 12.0, huone.ala(),0.1);
	}

	/**
	 * Testataan tilavuuden laskemista 
	 */
	@Test
	public void testTilavuus() {
		assertEquals("Tilavuus: ", 24.0, huone.tilavuus(),0.1);
	}

	/**
	 * Testataan kaappien lismist
	 */
	@Test
	public void testLisaaKaappeja() {
		assertEquals("Kaappeja: ", 0, huone.getKaappeja());
		huone.lisaaKaappeja();
		assertEquals("Kaappeja: ", 1, huone.getKaappeja());
		huone.lisaaKaappeja();
		assertEquals("Kaappeja: ", 2, huone.getKaappeja());
	}

}
