import java.io.*; // tarvitaan tietojen syttn

/**
 * Jarj3ta.java
 * Ohjelma jrjest kolme merkkijonoa aakkosjrjestykseen, taulukkototeutus
 *
 * @author Miika Nurminen
 * @version 0.1 01/20/03
 *
 */
public class Jarj3ta {

   /** mritetn taulukon koko vakiolla e*/
   public static final int KOKO = 3;

  /**
   * Vaihtaa kaksi taulukossa olevaa merkkijonoa keskenn.
   *
   * @param mjonot taulukko, jossa merkkijonot ovat
   * @param a ensimmisen vaihdettavan jonon indeksi.
   * @param b toisen vaihdettavan jonon indeksi.
   */
  public static void vaihda(String[] mjonot, int a, int b) {
    String t=mjonot[a];
    mjonot[a]=mjonot[b];
    mjonot[b]=t;
  }


  /**
   * Kysyy kyttjlt merkkijonon annetulla tulosteella.
   *
   * @param prompt lause, joka kyttj nkee ennen tietojen sytt
   * @return kyttjn syttm merkkijono ilman rivinvaihtoa
   */
  public static StringBuffer kysy(String prompt) {
      System.out.print(prompt);
      StringBuffer result = new StringBuffer();

      // Syttpyynt ja vastauksen lukeminen
      BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
      try {
          result.append(in.readLine());
      } catch (IOException ex) {
      }
      return result;
  }


  /**
   * Pohjelma
   *
   * @param args Komentorivill annetut parametetrit
   */
  public static void main(String[] args) {
    String[] jonot = new String[KOKO];
    int i,pienin,tutki;

  for (i=0; i<jonot.length; i++) {
    jonot[i] = kysy("Anna "+(i+1)+". merkkijono >").toString();
  }

  for (pienin=0; pienin<jonot.length-1; pienin++)     /* pienin aina paikkaan 0,1,2..*/
    for (tutki=pienin+1; tutki<jonot.length; tutki++) /* etsitn osataulukon pienin */
      if ( jonot[pienin].compareTo(jonot[tutki])>0 )
        vaihda(jonot,pienin,tutki);


  System.out.print("Jonot: ");
  for (i=0; i<jonot.length; i++)
    System.out.print(" "+jonot[i]);
  System.out.println();


  }

}
