import java.util.*; // comparator, Arrays
import java.io.*; // tarvitaan tietojen syttn

/**
 * Jarjta.java
 *
 * Ohjelma jrjest kolme merkkijonoa aakkosjrjestykseen, taulukkototeutus.
 * Jrjestminen Javan Array-luokan sort-metodilla.
 * @author Miika Nurminen
 * @version 0.1 01/20/03
 *
 */
public class Jarjta implements Comparator {

   /** mritetn taulukon koko vakiolla */
   public static final int KOKO = 4;


  /** Compares its two arguments for order.  Returns a negative integer,
  * zero, or a positive integer as the first argument is less than, equal
  * to, or greater than the second.<p>
  *
  * The implementor must ensure that <tt>sgn(compare(x, y)) ==
  * -sgn(compare(y, x))</tt> for all <tt>x</tt> and <tt>y</tt>.  (This
  * implies that <tt>compare(x, y)</tt> must throw an exception if and only
  * if <tt>compare(y, x)</tt> throws an exception.)<p>
  *
  * The implementor must also ensure that the relation is transitive:
  * <tt>((compare(x, y)&gt;0) &amp;&amp; (compare(y, z)&gt;0))</tt> implies
  * <tt>compare(x, z)&gt;0</tt>.<p>
  *
  * Finally, the implementer must ensure that <tt>compare(x, y)==0</tt>
  * implies that <tt>sgn(compare(x, z))==sgn(compare(y, z))</tt> for all
  * <tt>z</tt>.<p>
  *
  * It is generally the case, but <i>not</i> strictly required that
  * <tt>(compare(x, y)==0) == (x.equals(y))</tt>.  Generally speaking,
  * any comparator that violates this condition should clearly indicate
  * this fact.  The recommended language is "Note: this comparator
  * imposes orderings that are inconsistent with equals."
  *
  * @param o1 the first object to be compared.
  * @param o2 the second object to be compared.
  * @return a negative integer, zero, or a positive integer as the
  * 	       first argument is less than, equal to, or greater than the
  * 	       second.
  * @throws ClassCastException if the arguments' types prevent them from
  * 	       being compared by this Comparator.
  *
   */
  public int compare(Object o1, Object o2) {
    String s1 = o1.toString().toLowerCase();
    String s2 = o2.toString().toLowerCase();
    return s1.compareTo(s2);
  }


  /**
   * Kysyy kyttjlt merkkijonon annetulla tulosteella.
   *
   * @param prompt lause, joka kyttj nkee ennen tietojen sytt
   * @return kyttjn syttm merkkijono ilman rivinvaihtoa
   */
  public static StringBuffer kysy(String prompt) {
      System.out.print(prompt);
      StringBuffer result = new StringBuffer();

      // Syttpyynt ja vastauksen lukeminen
      BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
      try {
          result.append(in.readLine());
      } catch (IOException ex) {
      }
      return result;
  }

  /**
   * Pohjelma
   *
   * @param args Komentorivill annetut parametetrit
   */
  public static void main(String[] args) {
// taulukon jrjestmist kytettess ei tarvitse kytt StringBufferia
    String[] jonot = new String[KOKO];
    int i;

  for (i=0; i<jonot.length; i++) {
    jonot[i] = kysy("Anna "+i+". merkkijono >").toString();
  }

  Arrays.sort(jonot, new Jarjta()); // pluokka toimii itse vertailijana

  System.out.print("Luvut: ");
  for (i=0; i<jonot.length; i++)
    System.out.print(" "+jonot[i]);
  System.out.print("\n");

  }

}
