``` {#helloeka plugin="csPlugin"}
header: Java
type: java/jcomtest
byCode: |
 //
 package example;
 public class Laskuja {
     /** 
      * @example 
      * <pre name="test">
      *   summa(2,3) === 5;
      *   summa(-5,5) === 0;
      *  </pre>
      */
     public static int summa(int a, int b) {
         return a + b;
     }
     
     public static void main(String[] args) {
         System.out.println("Summa = " + summa(3,2));
     }
 }
```

``` {#javagra plugin="csPlugin"}
header: Java/Graphics
type: graphics
byCode: |
    //
    import fi.jyu.mit.graphics.EasyWindow;
    
    public class SimpleGraphics {
    
        public static void main(String[] args) {
            EasyWindow window = new EasyWindow();
            window.addLine(0,0,100,100);
            window.addCircle(50,50, 20);
        }
    }
```

``` {#hellocs plugin="csPlugin"}
header: C#
type: console/comtest
byCode: |
 //C#
 public class Laskuja
 {
     /// <example>
     /// <pre name="test">
     ///    Laskuja.Summa(2,3) === 5;
     ///    Laskuja.Summa(-5,5) === 0;
     /// </pre>
     /// </example>     
     public static int Summa(int a, int b)
     {
         return a + b;
     }
 
     public static void Main()
     {
         System.Console.WriteLine("Summa = " + Summa(2,3));
     }
 }
```

``` {#punainenympyra plugin="csPlugin"}
header: C# / JyPeli
type: jypeli 
maxrows: 20
file: https://svn.cc.jyu.fi/srv/svn/ohj1/luentomonistecs/esimerkit/Pohja/Jypeli/Jypeli.cs
replace: INSERT YOUR CODE HERE
byCode: |
 //
         Level.Background.Color = Color.Black;
         PhysicsObject pallo = new PhysicsObject(200,200,Shape.Circle);
         pallo.Color = Color.Yellow;
         Add(pallo);
```

``` {#helloc plugin="csPlugin"}
header: C
type: cc
byCode: |
 //
 #include <stdio.h>
 int main(void)
 {
   printf("Terve! Olen C-kielellä kirjoitettu ohjelma.\n");
   return 0;
 }
```

``` {#helloccc plugin="csPlugin"}
header: C ohjelma käännettynä C++:lla
type: c++
byCode: |
 //
 // C++ kääntäjällä
 #include <stdio.h>
 int main(void)
 {
   printf("Terve! Olen C-kielellä kirjoitettu ohjelma.\n");
   return 0;
 }
```

``` {#hellocpp plugin="csPlugin"}
header: C++
type: c++/ccomtest
byCode: |
 //
 // C++ -kieli
 #include <iostream>
 using namespace std;
 
 /** 
  * @example 
  * <pre name="test">
  *   summa(2,3) === 5;
  *   summa(-5,5) === 0;
  *  </pre>
  */
 int summa(int a, int b) {
     return a + b;
 }
     
 int main()
 {
     cout << "Summa = " << summa(2,3) << endl;
     return 0;
 }
```

``` {#hellopy plugin="csPlugin"}
header: Python 3
type: py
byCode: |
 # Python
 def summa(a,b):
    return a+b
    
 print("Summa = %d" % summa(2,3))    
```

``` {#hellofs plugin="csPlugin"}
header: F#
type: fs
byCode: |
 printfn "Hello World"
```

``` {#helloclisp plugin="csPlugin"}
header: Common Lisp (sbcl)
type: clisp
byCode: |
 ;; Common Lisp
 (defun summa (a b)
   "Laskee annetun kahden luvun summan."  ;; Näin tehdään docstring.
   (+ a b))

 (fresh-line)
 (format t "Summa = ~d~%" (summa 2 3))
```

``` {#floatvika plugin="csPlugin"}
header: Float ongelma / C#
program: |
 //
 using System;
 public class FloatOngelma
 {
     public static void Main()
     {
         // CODE
     }
 }
replace: CODE
byCode: |
 //
         float s = 0;
         float d = 0.1f;
         for (int i=0; i<1000; i++) s += d;
         Console.WriteLine("{0:0.00000000}",s);
```