package alkeet.alkuluku;
/**
 * Ohjelmalla testataan onko_alkuluku-aliohjelmaa
 * @author Vesa Lappalainen @version 20.1.2011
 * @author Santtu Viitanen @version 12.8.2011
 */
public class Alkuluku {

    /**
     * Aliohjelmalla tutkitaan onko parametrina tuotu
     * luku alkuluku vai ei<br>
     * Algoritmi: Jaetaan tutkittavaa lukua jakajilla 2,3,5,7...luku/2.
     * Jos jokin jako menee tasan, niin ei alkuluku:
     * 
     * @param luku tutkittava luku
     * @return luvun jolla jaollinen tai 1 jos alkuluku
     * @example
     * <pre name="test">
     * #STATICIMPORT 
     *   onkoAlkuluku(25)  === 5;
     *   onkoAlkuluku(2)   === 1;
     *   onkoAlkuluku(4)   === 2;
     *   onkoAlkuluku(123) === 3;
     *   onkoAlkuluku(7)   === 1;
     * </pre>
     * 
     * Testaamista esittelev versio @see {@link muuttujat.testaus.Alkuluku}}
     */
    public static int onkoAlkuluku(int luku) {
        int jakaja = 2;
        int kasvatus = 1;
        if ( luku == 2 ) return 1;                  // 0

        do {
            int jakojaannos = luku % jakaja;
            if (jakojaannos == 0) return jakaja; // 1
            jakaja += kasvatus; // 2
            kasvatus = 2; // 3

        } while (jakaja < luku / 2);        
        
        return 1;
    }
    
    /**
     * @param args ei kytet
     */
    public static void main(String[] args) {
        
        int luku = 25;
        int jaollinen;
        
        jaollinen = onkoAlkuluku(luku);
        
        if ( jaollinen == 1)
           System.out.println("alkuluku");
        else
            System.out.println("Jaollinen luvulla " + jaollinen);
        
    }
}
