package funktio.integroi;

/**
 * Ohjelmalla integroidaan numeerisesti funktio sin(x)
 * @author Vesa Lappalainen
 * @version 1.0, 25.03.2003
 */
public class Integroi {

    /**
     * Integroidaan sin(x) vlill x1-x2
     * @param x1 alkuarvo
     * @param x2 loppuarvo
     * @param tiheys monellako askeleella
     * @return likiarvo integraalille
     */
    public static double integroi(double x1, double x2, int tiheys) {
        double summa = 0;
        double dx = (x2-x1)/tiheys;
        for ( double x=x1+dx/2; x < x2; x += dx) 
            summa += Math.sin(x) * dx;
        return summa;
    }    
    
    
    /**
     * @param args ei kytss
     */
    public static void main(String[] args) {
        double ala = integroi(0,Math.PI,1000);
        System.out.printf("%17.15f%n",ala);
    }
}
