package funktio.integroi;

import java.awt.Color;

import fi.jyu.mit.graphics.*;
import static java.lang.Math.*;


/**
 * Esimerkki funktion piirtmisest.
 * Piirt sin-kyrn ja sille "integrointia" vastaavat pylvt 
 * @author vesal
 * @version 13.3.2012
 */
public class SinKuva {

    /**
     * Piirt numeerista integrointia vastaavat pylvt funktion kohdalle
     * @param space avaruus, johon pylvit piirretn
     * @param f      funktio, jolle pylvt piirretn
     * @param x1     alkupiste
     * @param x2     loppupiste
     * @param tiheys kuinka monta pylvst piirretn
     * @param vari mill vrill pylvt piirretn.
     */
    public static void piirraPylvaat(Space space, FunctionRR f, double x1, double x2, double tiheys, Color vari) {
        double dx = (x2- x1)/tiheys;

        for (double x=x1+dx/2 ; x<x2; x+=dx) {
            Rect pylvas = new Rect(x,f.f(x)/2,dx/2,f.f(x)/2);
            space.add(pylvas).setColor(vari);
        }
    }

    
    /**
     * @param args ei kytss
     */
    public static void main(String[] args) {
        FunctionRR f = x -> sin(x);
        
        double x1=0,x2=PI;
        double dx = 0.2;
        
        EasyWindow window = new EasyWindow(400,200);
        
        window.scale(x1-dx,-0.2,x2+dx,1.2);
        
        piirraPylvaat(window.getSpace(), f,x1,x2, 10, Color.blue);
        window.add(new FunctionMapRR(f,x1,x2,0));
        window.addAxis(10, 10, 10);
    }

}