package kombinatiot;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.List;
import java.util.regex.Pattern;

/**
 * Tarkistetaan onko tiedostosta input.txt saatava syöte sellaisia jonoja,
 * jotka täsmäävät annettuun RegExpiin.
 * Jonoja pitää olla täsmälleen n kappaletta ja niiden pitää olla erilaisia
 * keskenään. 
 * Tarkoitettu käytettäväksi lähinnä TIMin kanssa, joka muuttaa
 * vertailuarvoja tarpeen mukaan.
 * 
 * @author vesal
 * @version 18.1.2015
 *
 */
public class RegInputTarkistaja {

    private static int MAARA = 5; // MUUTAMAARA - montako jonoa pitää antaa
    private static String REGEXP = ".*"; // MUUTAREGEXP - tutkittava regexp, jota vastaan input.txt verrataan
    private static String REGEXPRAJ = ".*"; // MUUTARAJOITEREGEXP - rajoite jolla voidaan rajoittaa sallitut merkit
    private static int MIN=0, MAX=5000; // MUUTAPITUUSRAJAT - millä välillä jonon pituuden tulee olla
    private static boolean odotettuTulos = true; // MUUTATULOS - halutaanko match vai ei-match
    private static boolean tuloste = true; // TEETULOSTE - Halutaanko tuoste vai ei
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Path path = Paths.get("", "input.txt");
        int n = 0, i = 0;
        try {
            List<String> lines = Files.readAllLines(path);
            HashMap<String, String> tutkitut = new HashMap<String, String>();
            for (String s : lines) {
                s = s.trim();
                if (s.equals("")) continue;
                if ( tutkitut.containsKey(s) ) continue;
                tutkitut.put(s, s);
                i++;
                boolean match = Pattern.matches(REGEXP, s);
                boolean match2 = Pattern.matches(REGEXPRAJ, s);
                String tulos = match ? "hyväksyy" : "hylkää";
                String ok = "väärin";
                if ( s.length() < MIN || MAX < s.length() ) ok ="väärän pituinen";
                else if ( !match2 ) ok = "ei täytä rajoitetta "+ REGEXPRAJ;
                else if (match == odotettuTulos ) {
                    ok = "OK";
                    n++;
                }
                if ( tuloste ) System.out.println(i + " " + s + ": " + tulos + ", " + ok);
            }
        } catch (IOException e) {
            System.out.println("Talleta ensin tiedosto!");
        }
        
        if ( tuloste ) {
            if (n == MAARA)
                System.out.printf("Oli %d oikein.", MAARA);
            else
                System.out.printf("Oikeita oli %d/%d.", n, MAARA);
            if (i != MAARA)
                System.out.printf("\nOli %d jonoa, piti olla %d eri jonoa.", i, MAARA);
        } else {
            System.out.printf("Oli %d oikein.", n);
        }             
    }

}