/**
 * 
 */
package muuttujat.graafinen;

import java.awt.EventQueue;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.WindowConstants;
import javax.swing.border.EmptyBorder;

import fi.jyu.mit.ohj2.Mjonot;

/**
 * Ohjelma mittakaavan laskemiseksi
 * @author Vesa Lappalainen @version 1.0, 27.1.2011
 * @author Santtu Viitanen @version 1.1, 03.08.2011
 */
public class Mittakaava extends JFrame {

    /**  */
    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private final JLabel lblMittakaava = new JLabel("Mittakaava");
    private final JLabel label = new JLabel("1:");
    private final JTextField textMittakaava = new JTextField();
    private final JLabel lblKartaltaMitattuMatka = new JLabel("Kartalta mitattu matka");
    private final JTextField textKartalta = new JTextField();
    private final JLabel lblMm = new JLabel("mm");
    private final JLabel lblMatkaMaastossa = new JLabel("Matka maastossa");
    private final JTextField textMaastossa = new JTextField();
    private final JLabel lblKm = new JLabel("km");


    /**
     * @return viite kartalla kenttn
     */
    protected JTextField getTextKartalta() {
        return textKartalta;
    }


    /**
     * @return viiten mittakaava-kentn
     */
    protected JTextField getTextMittakaava() {
        return textMittakaava;
    }


    /**
     * Launch the application.
     * @param args Ei kytss
     */
    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Throwable e) {
            e.printStackTrace();
        }
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    Mittakaava frame = new Mittakaava();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }


    /**
     * Create the frame.
     */
    public Mittakaava() {
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowOpened(WindowEvent arg0) {
                getTextKartalta().requestFocus();
            }
        });
        textMaastossa.setEditable(false);
        textMaastossa.setColumns(10);
        getTextKartalta().addActionListener( a -> getTextKartalta().selectAll() ) ;
        getTextKartalta().addKeyListener(new KeyAdapter() {
            @Override
            public void keyReleased(KeyEvent arg0) {
                laske();
            }
        });
        getTextKartalta().setColumns(10);
        getTextMittakaava().addActionListener( a -> getTextMittakaava().selectAll() );
        getTextMittakaava().addKeyListener(new KeyAdapter() {
            @Override
            public void keyReleased(KeyEvent arg0) {
                laske();
            }
        });
        getTextMittakaava().setText("200000");
        getTextMittakaava().setColumns(10);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setBounds(100, 100, 355, 204);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(50, 20, 5, 20));
        setContentPane(contentPane);
        GridBagLayout gbl_contentPane = new GridBagLayout();
        gbl_contentPane.columnWidths = new int[]{0, 0, 0, 0, 0, 0};
        gbl_contentPane.rowHeights = new int[]{0, 0, 0, 0, 0};
        gbl_contentPane.columnWeights = new double[]{0.0, 0.0, 0.0, 1.0, 0.0, Double.MIN_VALUE};
        gbl_contentPane.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
        contentPane.setLayout(gbl_contentPane);
        
        GridBagConstraints gbc_lblMittakaava = new GridBagConstraints();
        gbc_lblMittakaava.anchor = GridBagConstraints.WEST;
        gbc_lblMittakaava.insets = new Insets(0, 0, 5, 5);
        gbc_lblMittakaava.gridx = 1;
        gbc_lblMittakaava.gridy = 1;
        contentPane.add(lblMittakaava, gbc_lblMittakaava);
        
        GridBagConstraints gbc_label = new GridBagConstraints();
        gbc_label.insets = new Insets(0, 0, 5, 5);
        gbc_label.anchor = GridBagConstraints.EAST;
        gbc_label.gridx = 2;
        gbc_label.gridy = 1;
        label.setHorizontalAlignment(SwingConstants.RIGHT);
        contentPane.add(label, gbc_label);
        
        GridBagConstraints gbc_textMittakaava = new GridBagConstraints();
        gbc_textMittakaava.insets = new Insets(0, 0, 5, 5);
        gbc_textMittakaava.fill = GridBagConstraints.HORIZONTAL;
        gbc_textMittakaava.gridx = 3;
        gbc_textMittakaava.gridy = 1;
        contentPane.add(getTextMittakaava(), gbc_textMittakaava);
        
        GridBagConstraints gbc_lblKartaltaMitattuMatka = new GridBagConstraints();
        gbc_lblKartaltaMitattuMatka.anchor = GridBagConstraints.WEST;
        gbc_lblKartaltaMitattuMatka.insets = new Insets(0, 0, 5, 5);
        gbc_lblKartaltaMitattuMatka.gridx = 1;
        gbc_lblKartaltaMitattuMatka.gridy = 2;
        contentPane.add(lblKartaltaMitattuMatka, gbc_lblKartaltaMitattuMatka);
        
        GridBagConstraints gbc_textKartalta = new GridBagConstraints();
        gbc_textKartalta.insets = new Insets(0, 0, 5, 5);
        gbc_textKartalta.fill = GridBagConstraints.HORIZONTAL;
        gbc_textKartalta.gridx = 3;
        gbc_textKartalta.gridy = 2;
        contentPane.add(getTextKartalta(), gbc_textKartalta);
        
        GridBagConstraints gbc_lblMm = new GridBagConstraints();
        gbc_lblMm.insets = new Insets(0, 0, 5, 0);
        gbc_lblMm.gridx = 4;
        gbc_lblMm.gridy = 2;
        contentPane.add(lblMm, gbc_lblMm);
        
        GridBagConstraints gbc_lblMatkaMaastossa = new GridBagConstraints();
        gbc_lblMatkaMaastossa.anchor = GridBagConstraints.WEST;
        gbc_lblMatkaMaastossa.insets = new Insets(0, 0, 0, 5);
        gbc_lblMatkaMaastossa.gridx = 1;
        gbc_lblMatkaMaastossa.gridy = 3;
        contentPane.add(lblMatkaMaastossa, gbc_lblMatkaMaastossa);
        
        GridBagConstraints gbc_textMaastossa = new GridBagConstraints();
        gbc_textMaastossa.insets = new Insets(0, 0, 0, 5);
        gbc_textMaastossa.fill = GridBagConstraints.HORIZONTAL;
        gbc_textMaastossa.gridx = 3;
        gbc_textMaastossa.gridy = 3;
        contentPane.add(textMaastossa, gbc_textMaastossa);
        
        GridBagConstraints gbc_lblKm = new GridBagConstraints();
        gbc_lblKm.gridx = 4;
        gbc_lblKm.gridy = 3;
        contentPane.add(lblKm, gbc_lblKm);
    }

    // Oma koodi
    
    /** Oletusmittakaava  */
    public static final double MITTAKAAVA = 200000.0;
    
    /** Kerroin mm muuttamiseksi km */
    public static final double MM_KM = 1000.0 * 1000.0;
    
    
    /**
     * Muunnetaan kartalta mm mitattu matka maastoon km
     * @param matka_mm kartalta mitattu matka mm
     * @param mittakaava kytettv mittakaava
     * @return matka maastossa km
     */
    public static double mittakaavamuunnos(double matka_mm, double mittakaava) {
        return mittakaava*matka_mm / MM_KM;
    }
    
    
    /**
     * Haetaan tekstikentst luku
     * @param text kentt josta haetaan
     * @param oletus luvun arvo jos kentst ei saa jrkev lukua
     * @return kentst haettu luku
     * @example
     * <pre name="test">
     * #TOLERANCE=0.01
     * #import javax.swing.JTextField;
     * haeLuku(new JTextField("234.233"), 44) ~~~ 234.23;
     * haeLuku(new JTextField("foobar1"), 44) ~~~ 44.00;
     * haeLuku(new JTextField("1foobar"), 44) ~~~ 1.00;
     * </pre>
     */
    public static double haeLuku(JTextField text,double oletus) {
        double luku = Mjonot.erotaDouble(text.getText(), oletus);
        return luku;
    }
    
    
    /**
     * Laittaa tekstikenttn tuloksen
     * @param text kentt johon luku laitetaan
     * @param luku joka laitetaan kenttn
     */
    public static void laitaTulos(JTextField text, double luku) {
        String tulos = String.format("%5.2f",luku);
        tulos = tulos.replace(',', '.');
        text.setText(tulos);
    }
    
    
    /**
     * Lasketaan uudet arvot muuttuneiden perusteella
     */
    protected void laske() {
        double mittakaava = haeLuku(getTextMittakaava(),MITTAKAAVA); 
        double matka_mm = haeLuku(getTextKartalta(), 0);
        double matka_km = mittakaavamuunnos(matka_mm,mittakaava);
        laitaTulos(textMaastossa,matka_km);
    }
    
    
    
}
