package taulukot;

/**
 * Matriisi parametrina
 * @author Vesa Lappalainen
 * @version 1.0, 04.03.2003
 */
public class Mat2 {

    /**
     * Lasketaan matriisin alkioiden summa
     * @param mat matriisi jonka summa lasketaan
     * @return alkioiden summa
     * @example
     * <pre name="test">
     *    double mat[][] = { { 1, 2, 3, 4 }, { 5, 6, 7, 8 } };
     *    alkioidenSumma(mat) ~~~ 36; 
     *    double mat0[][] = { {  }, {  } };
     *    alkioidenSumma(mat0) ~~~ 0; 
     *    double mat2[][] = { { 1, 2, 3 }, { 5 } };
     *    alkioidenSumma(mat2) ~~~ 11; 
     * </pre>
     */
    public static double alkioidenSumma(double mat[][]) {
        double summa = 0;
        int riv = mat.length;
        for (int i = 0; i < riv; i++) {
            int sar = mat[i].length;
            for (int j = 0; j < sar; j++)
                summa += mat[i][j];
        }
        return summa;
    }


    /**
     * Lasketaan matriisin alkioiden summa foreach-silmukalla
     * @param mat matriisi jonka summa lasketaan
     * @return alkioiden summa
     * @example
     * <pre name="test">
     *    double mat[][] = { { 1, 2, 3, 4 }, { 5, 6, 7, 8 } };
     *    summa(mat) ~~~ 36; 
     *    double mat0[][] = { {  }, {  } };
     *    summa(mat0) ~~~ 0; 
     *    double mat2[][] = { { 1, 2, 3 }, { 5 } };
     *    summa(mat2) ~~~ 11; 
     * </pre>
     */
    public static double summa(double mat[][]) {
        double summa = 0;
        for (double[] rivi : mat) 
            for (double luku : rivi)
                summa += luku;
        return summa;
    }


    /**
     * Testataan summaa
     * @param args ei kytss
     */
    public static void main(String[] args) {
        double s1, s2, s3;
        double yks[][] = { { 1.0, 0.0, 0.0 }, { 0.0, 1.0, 0.0 },
                { 0.0, 0.0, 1.0 } };
        double mat2[][] = { { 1, 2, 3, 4 }, { 5, 6, 7, 8 } }, mat3[][] = {
                { 1, 0, 0 }, { 0, 1, 0 }, { 0, 0, 1 } };
        s1 = alkioidenSumma(yks);
        s2 = alkioidenSumma(mat2);
        s3 = alkioidenSumma(mat3);
        System.out.println("Summat ovat " + s1 + ", " + s2 + " ja " + s3);
    }
}
