package taulukot;

/**
 * Matriisi kasattuna irrallisista riveist
 * @author Vesa Lappalainen
 * @version 1.0, 04.03.2003
 */
public class Mat3 {

    /**
     * Lasketaan osamatrsiin summa  
     * @param mat matriisin jonka osan summa lasketaan
     * @param riveja monenko rivin summa lasketaan
     * @param sarakkeita momenko sarakkeen summa lasketaan
     * @return osamatriisin summa
     * @example
     * <pre name="test">
     *    double mat[][] = { { 1, 2, 3, 4 }, { 5, 6, 7, 8 } };
     *    alkioidenSumma(mat,20,20) ~~~ 36; 
     *    alkioidenSumma(mat,1,2) ~~~ 3; 
     *    alkioidenSumma(mat,2,2) ~~~ 14; 
     * </pre>
     */
    public static double alkioidenSumma(double mat[][], int riveja, int sarakkeita) {
        int riv = Math.min(riveja, mat.length);
        double summa = 0;
        for (int i = 0; i < riv; i++) {
            int sar = Math.min(sarakkeita, mat[i].length);
            for (int j = 0; j < sar; j++)
                summa += mat[i][j];
        }
        return summa;
    }


    /**
     * Testataan osasummaa
     * @param args ei kytss
     */
    public static void main(String[] args) {
        double s1, s2;
        double r0[] = { 1, 2, 3, 4 }, r1[] = { 5, 6, 7, 8 }, r2[] = { 9, 0, 1,
                2 };
        double mat[][] = { r0, r1, r2 };
        s1 = alkioidenSumma(mat, 2, 3);
        s2 = alkioidenSumma(mat, 3, 4);
        System.out.println("Summat on " + s1 + " ja " + s2);

    }
}
