package tiedosto;
import java.io.*;

import fi.jyu.mit.ohj2.*;

/**
 * Ohjelmalla tutkitaan tiedoston kytt
 * @author Vesa Lappalainen
 * @version 1.0, 21.02.2003
 */
public class TiedostoTesti {

  /**
   * @param args ei kytss
   * @throws IOException jos tulee virhe
   */
  public static void main(String[] args) throws IOException {
    File fbak = new File("testi.bak");
    File ftied = new File("testi.dat");

    @SuppressWarnings("resource")
    PrintWriter fo = Tiedosto.avaa_kirjoittamista_varten(ftied.getName());
    if ( fo == null ) { System.err.println("Ei voi kirjoittaa"); return; }

    try {
      fo.println("Kissa istuu puussa");
    } finally {
      fo.close();
    }

    if ( !fbak.delete() ) System.out.println("Ei voi tuhota");
    if ( !ftied.renameTo(fbak) ) System.out.println("Ei voi nimet");
    System.out.println(ftied.getName() + " => " + fbak.getName());
    System.out.println(ftied.getAbsolutePath() + " => " + fbak.getAbsolutePath());

    @SuppressWarnings("resource")
    BufferedReader fi = Tiedosto.avaa_lukemista_varten(fbak.getName());
    if ( fi == null ) { System.err.println("Ei voi lukea"); return; }

    try {
      String s;
      while ( ( s = fi.readLine() ) != null ) {
        System.out.println(s);
      }
    } finally {
      fi.close();
    }
  }
}
