# Input eri kielillä

``` {#inputJava plugin="csPlugin"}
type: java/input
header: java
inputplaceholder: "Kirjoita ohjelman syöte tähän, kukin jono omalle rivilleen"
inputstem: "Anna syöte"
inputrows: 3
stdin: input.txt
byCode: |
 package kokeiluja;
 
 import java.util.Scanner;
 import java.io.IOException;
 import java.io.BufferedReader;
 import java.io.IOException;
 import java.io.InputStreamReader;
 
 /**
  * @author vesal
  * @version 16.1.2015
  */
 public class Kysymys3a {
 
     /**
      * @param args ei käytössä
      */
     public static void main(String[] args) throws IOException {
         // String input = System.console().readLine();
         // BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
         Scanner sc = new Scanner(System.in);
         while ( sc.hasNextLine() ) {
             // String input = br.readLine();
             String input = sc.nextLine();
             if ( input == null ) break;
             System.out.println("Syöttö oli: " + input);
         }
         System.out.println("Loppu");
     }
 }
```

``` {#inputCS plugin="csPlugin"}
type: console/input
header: C#
inputplaceholder: "Kirjoita ohjelman syöte tähän, kukin jono omalle rivilleen"
inputstem: "Anna syöte"
inputrows: 3
stdin: input.txt
byCode: |
 using System;
 
 /// <summary>
 /// Harjoitellaan do-while-silmukan käyttöä.
 /// </summary>
 public class NimenTulostus
 {
     /// <summary>
     /// Pyydetään käyttäjältä syöte ja tulostellaan.
     /// </summary>
     public static void Main()
     {
         String nimi;
         do
         {
             Console.Write("Anna nimi > ");
             nimi = Console.ReadLine();
         } while (nimi != null && nimi.Length == 0);
         Console.WriteLine();
         Console.WriteLine("Hei, " + nimi + "!");
     }
 }
```

``` {#inputPY3 plugin="csPlugin"}
type: py3/input
header: Python 3
inputplaceholder: "Kirjoita ohjelman syöte tähän, kukin jono omalle rivilleen"
inputstem: "Anna syöte"
inputrows: 3
stdin: input.txt
byCode: |
 input_var = input("Enter something: ")
 print ("you entered " + input_var) 
```

``` {#inputCPP plugin="csPlugin"}
type: c++/input
header: C#
inputplaceholder: "Kirjoita ohjelman syöte tähän, kukin jono omalle rivilleen"
inputstem: "Anna syöte"
inputrows: 3
stdin: input.txt
byCode: |
 //
 // C++ -kieli
 #include <iostream>
 using namespace std;
     
 int main()
 {
     string s;
     cout << "Anna jotakin >";
     getline(cin,s);
     cout << "Annoit: " << s;
     return 0;
 }  
```

``` {#inputC plugin="csPlugin"}
type: cc/input
header: C
inputplaceholder: "Kirjoita ohjelman syöte tähän, kukin jono omalle rivilleen"
inputstem: "Anna syöte"
inputrows: 3
stdin: input.txt
byCode: |
 #include <stdio.h>
 int main(void)
 {
   char s[50];
   printf("Anna jotakin");
   fgets(s, sizeof(s), stdin);
   printf("Annoit: %s\n",s);
   return 0;
 }
```

``` {#inputLisp plugin="csPlugin"}
header: Common Lisp (sbcl)
type: clisp/input
inputplaceholder: "Kirjoita ohjelman syöte tähän, kukin jono omalle rivilleen"
inputstem: "Anna syöte"
inputrows: 3
stdin: input.txt
byCode: |
 (format t "Enter some text: ")
 (let ((s (read-line)))
     (format t "You entered ~s~%" s))
  
 (format t "Enter a number: ")
 (let ((n (read)))
     (if (numberp n)
         (format t "You entered ~d.~%" n)
       (format t "That was not a number.")))
```

``` {#inputFS plugin="csPlugin"}
header: F#
type: fs/input
inputplaceholder: "Kirjoita ohjelman syöte tähän, kukin jono omalle rivilleen"
inputstem: "Anna syöte"
inputrows: 3
stdin: input.txt
byCode: |
 module Program
  
 open System
  
 // Declare the main function
 let main() =
     // Ask the user for input
     Console.Write("Enter your input: ")
  
     // Read user input
     let input = Console.ReadLine()
  
     // Print the entered input
     Console.Write("You entered: {0}", input)
  
     // Used for pausing the console application
     Console.ReadLine() |> ignore
  
 // Execute the main function
 main()
```





