<?xml version="1.0" encoding="iso-8859-1"?>
<!--
wordin filtteroidusta html:st siistityksi www-sivuksi
siistii koodia ja lis luku- ja tehtvkohtaiset paikalliset linkit.
Miika Nurminen, 5.1.2012
-->
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:h="http://www.w3.org/1999/xhtml">
<!-- include has same precedence, import has lower-->
<xsl:include href="commons.xsl" />
<xsl:strip-space elements="*" /> 
<xsl:preserve-space elements="h:a h:font h:p h:pre h:span" />

  <!-- mozilla doesn't parse method xhtml (in xslt 2.0) -->
  <xsl:output method="xml"
  version="1.0"
  encoding="ISO-8859-1"
  omit-xml-declaration="no"
  indent="no"
  doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
  doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
  />
  
  <xsl:param name="imgdir">../html/</xsl:param>


<xsl:template match="h:style">
<xsl:element name="h:link">
  <xsl:attribute name="type">text/css</xsl:attribute>
  <xsl:attribute name="rel">stylesheet</xsl:attribute>  
  <xsl:attribute name="href">word.css</xsl:attribute>
</xsl:element>
<xsl:element name="h:link">
  <xsl:attribute name="type">text/css</xsl:attribute>
  <xsl:attribute name="rel">stylesheet</xsl:attribute>  
  <xsl:attribute name="href">../skriptit/treestyles.css</xsl:attribute>
</xsl:element>
<xsl:element name="h:link">
  <xsl:attribute name="type">text/css</xsl:attribute>
  <xsl:attribute name="rel">stylesheet</xsl:attribute>  
  <xsl:attribute name="href">../skriptit/omat_link.css</xsl:attribute>
</xsl:element>
</xsl:template>

<!--
<span style='font-family:Symbol'>&#8226;
-->
<!-- listasymbolin koon kasvatus -->
<xsl:template match="h:span">
<xsl:choose>
<xsl:when test="@style='font-family:Symbol' and contains(.,'&#8226;')">
<h:span style="font-family:Symbol;font-size:1.5em">&#8226;&#160;</h:span>
</xsl:when>
<xsl:otherwise><xsl:copy><xsl:apply-templates select="node()|@*"/></xsl:copy></xsl:otherwise>
</xsl:choose>
</xsl:template>

<!-- yhtenistetn koodiesimerkkien laatikot -->
<!-- or child::div[child::h:p[@class='lgohjelma' or @class='gohjelma']]-->
<xsl:template match="h:div[(child::h:p[@class='lgohjelma' or @class='gohjelma'])
]">
<h:div style='border:solid windowtext 1.5pt;padding:5.0pt 5.0pt 5.0pt 5.0pt; margin-left:2.0cm;margin-right:5.1pt'>
<xsl:apply-templates select="h:p"/>
</h:div>
</xsl:template>

<!-- kelmit.dat - ensimminen ehdotus tiedostoksi,  Dyn.olion.luonti  -->
<xsl:template match="h:div[(child::h:p[@class='ohjotsH' or @class='ohjotsHntoc'])
]">
<h:div style='border:solid windowtext 1.5pt;padding:2.0pt 2.0pt 2.0pt 2.0pt; background:#E5E5E5;margin-left:2.0cm;margin-right:5.1pt'>
<xsl:apply-templates select="h:p"/>
</h:div>
</xsl:template>


<!-- case Tiedot jsenen yhteyteen, siskkinen div sotkee marginaalit -->
<xsl:template match="h:div[count(child::node())=1 and child::h:div]">
<xsl:apply-templates select="*" />
</xsl:template>

<xsl:template match="h:img">
      <xsl:element name="h:img">
        <xsl:attribute name="src"><xsl:value-of select="$imgdir" /><xsl:value-of select="@src" /></xsl:attribute>
        <xsl:attribute name="alt"><xsl:choose>
          <xsl:when test="string-length(@alt) &gt; 0"><xsl:value-of select="@alt" /></xsl:when>
          <xsl:otherwise>kuva</xsl:otherwise>
        </xsl:choose></xsl:attribute>        
        <xsl:copy-of select="node()|@*[(local-name()!='src') and (local-name()!='id') and (local-name()!='name') and (local-name()!='alt')]"/> <!-- wordin id:t epvalidit, esim "Figure 7" => suodatetaan pois -->
      </xsl:element>
  </xsl:template>
 
    <xsl:template match="h:a">
    <xsl:choose>
    <xsl:when test="(@href and  (string-length(normalize-space(.)) &gt; 0)) or @id or @name">
      <xsl:element name="h:a">
        <xsl:attribute name="href">
        <xsl:choose>
        <xsl:when test="substring(@href,1,1)='#'">#<xsl:call-template name="fix_id_nopos">
   <xsl:with-param name="s"><xsl:value-of select="substring(@href,2)" /></xsl:with-param>
  </xsl:call-template></xsl:when>
        <xsl:otherwise><xsl:value-of select="@href" /></xsl:otherwise>
        </xsl:choose>
        </xsl:attribute>
        
        <xsl:if test="@id and (string-length(@href)=0)"><xsl:attribute name="id"><xsl:call-template name="fix_id_nopos">  <!-- fix_id -->
   <xsl:with-param name="s"><xsl:value-of select="@id" /></xsl:with-param>
  </xsl:call-template></xsl:attribute></xsl:if>
        <xsl:if test="@name and (string-length(@href)=0)"><xsl:attribute name="name"><xsl:call-template name="fix_id_nopos">  <!-- fix_id -->
   <xsl:with-param name="s"><xsl:value-of select="@name" /></xsl:with-param>
  </xsl:call-template></xsl:attribute></xsl:if>
  <xsl:choose>
  <xsl:when test="ancestor::h:h1 or ancestor::h:h2 or ancestor::h:h3 or ancestor::h:h4 or ancestor::h:p[@class='TehtOts' or @class='TehtOts1' or @class='ohjotsH' or @class='MsoCaption']">
<xsl:apply-templates select="@*[(local-name()!='href') and (local-name()!='id') and (local-name()!='name')]"/>  </xsl:when> 
  <xsl:otherwise>
<xsl:apply-templates select="node()|@*[(local-name()!='href') and (local-name()!='id') and (local-name()!='name')]"/>
  </xsl:otherwise>
  </xsl:choose>
      </xsl:element><!-- kuvien ja koodinptkien alku tekstin  -->
      <xsl:if test="ancestor::h:p[@class='ohjotsH' or @class='MsoCaption']">
      <xsl:apply-templates select="node()" />
  </xsl:if>
      </xsl:when>
      <xsl:otherwise><xsl:text> </xsl:text></xsl:otherwise>
      </xsl:choose>
  </xsl:template>

  
 
   
<!--   <xsl:template match="h:a" mode="notext">
   <xsl:copy><xsl:apply-templates select="@*"/>
   </xsl:copy>
 </xsl:template>  
-->
  <!-- remove class and copy text after picture, if exists -->
   <xsl:template match="h:h1 | h:h2 | h:h3 | h:h4 | h:p[@class='TehtOts'] | h:p[@class='TehtOts1']">
   
   <xsl:variable name="id"><xsl:call-template name="fix_id_nopos"> <!-- fix_id -->
   <xsl:with-param name="s"><xsl:value-of select="h:a/@name" /></xsl:with-param>
  </xsl:call-template></xsl:variable>
  
  
  <xsl:apply-templates select="h:a" /><!-- mode="notext" -->

  
<!--   <xsl:element name="a">
   <xsl:attribute name="name"><xsl:value-of select="$id" /></xsl:attribute>
   <xsl:attribute name="id"><xsl:value-of select="$id" /></xsl:attribute>
   </xsl:element>
   -->
  
   <xsl:variable name="content">
<!--    <xsl:apply-templates select="text()|h:span|h:font" />-->
<!--<xsl:apply-templates select="node()" mode="textonly" />-->
<!--<xsl:call-template name="text">
<xsl:with-param name="s" select="." />
</xsl:call-template>-->
<xsl:value-of select="." />
   <xsl:if test="(local-name(following-sibling::*[1])='p')
         and (local-name(following-sibling::*[2])='br')">
   <xsl:choose>
         <xsl:when test="local-name(following-sibling::*[3])='span'">
      <xsl:call-template name="text">
          <xsl:with-param name="s" select="following-sibling::*[3]/text()" />
         </xsl:call-template>

         </xsl:when>
         <xsl:otherwise> <!-- case:tikkataulu -->
         <xsl:call-template name="text" >
          <xsl:with-param name="s" select="following-sibling::node()[3]" />
         </xsl:call-template>
         </xsl:otherwise>
   </xsl:choose>
   </xsl:if>
  </xsl:variable>
   
<xsl:if test="string-length(normalize-space($content)) &gt; 0" >   
   <xsl:element name="div">
   <xsl:attribute name="class">header</xsl:attribute>

  <xsl:if test="string-length($id) &gt; 0"> <!-- id on luku-elementiss, ei otsikossa -->
<xsl:element name="p">
<xsl:attribute name="class">links<xsl:choose>
<xsl:when test="local-name(.)='h1'">_h1</xsl:when>
<xsl:when test="local-name(.)='h2'">_h2</xsl:when>
<xsl:otherwise  />
</xsl:choose></xsl:attribute>
<xsl:element name="a">
<!--  <xsl:attribute name="id"><xsl:value-of select="$id"/></xsl:attribute>
  <xsl:attribute name="name"><xsl:value-of select="$id"/></xsl:attribute>-->
  <xsl:attribute name="title">Pysyv linkki</xsl:attribute>
  <xsl:attribute name="class">anchor</xsl:attribute>
<!--<xsl:if test="string-length($tiedosto) = 0"><xsl:attribute name="target">_parent</xsl:attribute></xsl:if>-->
  <xsl:attribute name="href">#<xsl:value-of select="$id"/></xsl:attribute>#</xsl:element>
  <xsl:text> </xsl:text>
<xsl:element name="a">
<!--  <xsl:attribute name="id"><xsl:value-of select="$id"/></xsl:attribute>
  <xsl:attribute name="name"><xsl:value-of select="$id"/></xsl:attribute>-->
  <xsl:attribute name="title">Pysyv linkki (kehykset)</xsl:attribute>
  <xsl:attribute name="class">anchor</xsl:attribute>
   <xsl:attribute name="target">_parent</xsl:attribute>
<xsl:attribute name="href">./?id=<xsl:value-of select="$id"/></xsl:attribute>
  #</xsl:element>
</xsl:element>
</xsl:if>
    
   <xsl:copy>
    <xsl:apply-templates select="@*[(local-name()!='style')]" /> <!-- (local-name()!='class') and  -->
    <xsl:value-of select="normalize-space($content)" />   
   </xsl:copy>
   </xsl:element>

   </xsl:if>

 </xsl:template>  


 
 <!-- identity transform -->
 <xsl:template match="node()|@*">
   <xsl:copy><xsl:apply-templates select="node()|@*"/>
   </xsl:copy>
 </xsl:template>  
 

</xsl:stylesheet>