package fi.jyu.mit.gui;

import java.util.ArrayList;

/**
 * Sislt valmiiksi listan taulukkoon laitettaville olioille. Muiden tarpeellisten
 * toimintojen sislt riippuu sisn laitettavien olioiden omista ominaisuuksista.<br/>
 * Luokka toimii vain tilapisen olioiden sijoituspaikkana.
 * @author Samu Tuominen
 * @version 12.4.2011
 * @param <T> sisnlaitettavien olioiden luokka
 */
public abstract class AbstractTableObject<T> implements TableObject {
    
    /**
     * Listaus sisllytetyist olioista.
     */
    protected ArrayList<T> oliot = new ArrayList<T>();
    
    /**
     * Alustetaan luokan sislt ennen ObjectTablelle antamista.<br/>
     * Kytt taulukolle antamisen jlkeen rikkoo paikat.
     * @param object sisllytettv olio
     */
    public void add(T object) {
        oliot.add(object);
    }

    @Override
    public int getObjectCount() {
        return oliot.size();
    }

}
