package fi.jyu.mit.gui;

import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

/**
 *
 * @author Samu Tuominen
 * @version 4.4.2011
 */
public class DoubleCellEditor extends StringCellEditor {

    private static final long serialVersionUID = 1L;


    /**
     * Alustetaan editori tietty taulukkoa varten.
     * @param objects riveihin kiinni liimattavat oliot
     */
    public DoubleCellEditor(TableObject objects) {
        super(objects);
    }


    /**
     * Ksitelln arvo, joka on muuttunut editoinnin tuloksena
     * @param table taulukko, josta editointi tuli
     * @param s kentn uusi arvo
     * @return null=ok, muut virheilmoituksia
     */
    @Override
    protected String handleNewValue(JTable table, String s) {
        String ok = null;
        try {
            Double luku = new Double(Double.parseDouble(s));
            if ( oliot != null ) ok = oliot.setAttribute(getNr(), getKentta(), luku);
            if ( ok != null ) return ok;
            ok = ((ICTable)table).checkAttribute(getNr(), getKentta(), luku);
            if ( ok == null ) table.setValueAt(luku, getIrow(), getIcol());
            return ok;
        } catch (NumberFormatException n) {
            return "Ei luku " + s;
        }
    }

    
    
    /**
     * Asetetaan miss laidassa editoidaan
     * @param cellEditor editoitava kentt
     */
    @Override
    protected void setAlignment(JTextField cellEditor) {
        cellEditor.setHorizontalAlignment(SwingConstants.TRAILING);
    }
    
    
}
