package fi.jyu.mit.gui;

import java.awt.BorderLayout;
import javax.swing.JComboBox;
import javax.swing.JPanel;

/**
 * Paneli, jossa on valittavat kohteet ComboBox-komponentissa
 * @author vesal
 * @version 20.3.2011
 * @param <T> Ksiteltv tyyppi
 *
 */
public class GenComboBoxChooser<T> extends AbstractChooser<T> {
    private static final long serialVersionUID = 1L;

    private final JComboBox<String> comboBox = new JComboBox<String>();
    /**
     * @return combobox
     */
    public JComboBox<String> getComboBox() {
        return comboBox;
    }


    private final JPanel panel = new JPanel();
//    private final JComboBox comboBox = new JComboBox(); // TODO 1.6

    /**
     * Create the panel.
     */
    public GenComboBoxChooser() {
        super();
        setBorder(null);

        setKohteet(getKohteet());
        
        add(panel, BorderLayout.CENTER);
        panel.setLayout(new BorderLayout(0, 0));
        panel.add(comboBox, BorderLayout.NORTH);
        comboBox.addActionListener(this);
        
                comboBox.setModel(getModel());
    }


    /**
     * @see IStringListChooser#getSelectedIndex()
     */
    @Override
    protected int getSelectedIndexIntern() {
        return comboBox.getSelectedIndex();
    }


    /**
     * @see IStringListChooser#setSelectedIndex(int)
     */
    @Override
    protected void setSelectedIndexIntern(int selectedIndex, boolean value) {
        int i = selectedIndex;
        int max = getKohteet().length;
        if ( i >= max ) i = max-1;
        if ( value ) {
            comboBox.setSelectedIndex(i);
        }
        else comboBox.setSelectedIndex(-1);
        
    }


    /**
     * Asettaa mallin
     * @param model mallilista jota kytetn
     */
    @Override
    public void setModel(GenStringListModel<T> model) {
        super.setModel(model);
        comboBox.setModel(getModel());
    }


    @Override
    public void clearSelection() {
        comboBox.setSelectedIndex(-1);
    }
    
}
