package fi.jyu.mit.gui;

/**
 * Olio johon voi liitt tekstin ja merkkijonon.
 * @author Samu Tuominen
 * @version 6.4.2011
 */
public class ObjectStringPair implements Comparable<ObjectStringPair> {

    private Object teksti;
    private Object arvo;


    /**
     * Alustaa parin olioparilla.
     * @param s tekstiarvo
     * @param obj sisltolio
     */
    public ObjectStringPair(Object s, Object obj) {
        teksti = s;
        arvo = obj;
    }


    @Override
    public String toString() {
        return teksti.toString();
    }


    /**
     * Palauttaa parin tekstiarvon.
     * @return tekstiarvo
     */
    public Object getValue() {
        return teksti;
    }


    /**
     * Vaihtaa parin tekstiarvon.
     * @param s tekstiarvo
     */
    public void setValue(Object s) {
        teksti = s;
    }


    /**
     * Palauttaa parin olioarvon.
     * @return sisltolio
     */
    public Object getObject() {
        return arvo;
    }


    /**
     * Palauttaa parin olioarvon.
     * @param obj sisltolio
     */
    public void setObject(Object obj) {
        arvo = obj;
    }


    @Override
    public int compareTo(ObjectStringPair verrattava) {
        try {
          if ( teksti instanceof Double ) return ( ((Double)teksti).compareTo((Double)(verrattava.teksti) )); 
          if ( teksti instanceof Integer ) return ( ((Integer)teksti).compareTo((Integer)(verrattava.teksti) ));
        } catch (ClassCastException e) {
           // 
        }
        return (teksti.toString()).compareTo(verrattava.getValue().toString());
    }

}
