package fi.jyu.mit.gui;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

/**
 * Luotu 24.3.2011.
 * @author Samu Tuominen
 * @version 26.3.2011
 * TODO: metodien nimet englanniksi
 * TODO: voisiko kytt tablen omaa modelia?  Silloin voisi tablen asetuksia muutella builderist ksin.
 * TODO: tapahtuma kun klikataan jotakin solua
 * TODO: tapahtuma kun editoidaan jotakin solua
 * TODO: solujen vrin asettaminen (tausta + kirjain)
 * TODO: undo solujen editointiin
 * TODO: kun soluun tullaan, se saisi menn valituksi kokonaan jolloin siihen olisi helpompi aloittaa kirjoittamaan
 * TODO: olion liittminen soluun ja/tai riviin
 */
public class StringTableOld extends JPanel {
    
    private static final long serialVersionUID = 1L;
    private final JScrollPane scrollPane = new JScrollPane();
    private JTable table;
    private TableModelString muotti;
    
    /**
     * Muodostaa uuden tyhjn StringTable:n.
     */
    public StringTableOld() {
        this(new TableModelString());
    }
    
    
    /**
     * Muodostaa uuden StringTable:n annetulla sisltmodelilla.
     * @param model mit taulukkoon laitetaan sislle
     */
    public StringTableOld(TableModelString model) {
        setLayout(new BorderLayout(0, 0));
        muotti = model;
        table = new JTable(model);
        
        add(scrollPane);
        scrollPane.setViewportView(table);
    }
    
    
    /**
     * Muodostaa uuden StringTable:n ja alustaa sen annetuilla mrill tyhji rivej
     * ja sarakkeita.
     * @param riveja montako rivi halutaan
     * @param sarakkeita montako saraketta halutaan
     */
    public StringTableOld(int riveja, int sarakkeita) {
        this(new TableModelString(riveja, sarakkeita));
    }
    
    
    /**
     * Luo uuden taulukon annetulla sisllll ja nime sarakkeiden otsikot
     * automaattisesti (huonot nimet).
     * @param sisalto mit taulukkoon aluksi laitetaan
     */
    public StringTableOld(Matriisi<String> sisalto) {
        this(new TableModelString(sisalto));
    }
    
    
    /**
     * Muodostaa uuden StringTable:n ja alustaa sen annetuilla sisllll ja
     * sarakkeiden nimill.
     * @param sisalto mit taulukkoon aluksi laitetaan
     * @param nimet sarakkeiden nimet
     */
    public StringTableOld(Matriisi<String> sisalto, String[] nimet) {
        this(new TableModelString(sisalto, nimet));
    }
    
    
    /**
     * Luo uuden taulukon annetulla sisllll ja nime sarakkeiden otsikot
     * automaattisesti (huonot nimet).
     * @param sisalto mit taulukkoon aluksi laitetaan
     */
    public StringTableOld(String[][] sisalto) {
        this(new TableModelString(sisalto));
    }
    
    
    /**
     * Muodostaa uuden StringTable:n ja alustaa sen annetuilla sisllll ja
     * sarakkeiden nimill.
     * @param sisalto mit taulukkoon aluksi laitetaan
     * @param nimet sarakkeiden nimet
     */
    public StringTableOld(String[][] sisalto, String[] nimet) {
        this(new TableModelString(sisalto, nimet));
    }
    
    
    /**
     * Muodostaa uuden StringTable:n ja alustaa sen annetuilla sarakkeiden nimill ja
     * halutulla mrll tyhji rivej.
     * @param nimet sarakkeiden nimet
     * @param riveja montako rivi halutaan
     */
    public StringTableOld(String[] nimet, int riveja) {
        this(new TableModelString(nimet, riveja));
    }
    
// sarakkeiden ksittely

    /**
     * @param headings taulukon otsikot
     */
    public void setHeadings(String[] headings) {
        setModel(new TableModelString(headings,getRowCount()));
    }
    
    
    /**
     * @return taulukon otsikot
     */
    public String[] getHeadings() {
        return getModel().getColumnNames();
    }
    
    
    /**
     * Lis annetun mrn tyhji sarakkeita matriisiin.
     * @param maara montako tyhj saraketta halutaan
     * @param nimet sarakkeiden otsikot
     * @return onnistuiko sarakkeiden lisminen
     */
    public boolean lisaaSarakkeita(int maara, String[] nimet) {
        return muotti.lisaaSarakkeita(maara, nimet);
    }
    
    
    /**
     * Lis annetun mrn tyhji sarakkeita matriisiin.
     * @param maara montako tyhj saraketta halutaan
     * @param minne monennenko sarakkeen paikalle laitetaan
     * @param nimet sarakkeiden otsikot
     * @return onnistuiko sarakkeiden lisminen
     */
    public boolean lisaaSarakkeita(int maara, int minne, String[] nimet) {
        return muotti.lisaaSarakkeita(maara, minne, nimet);
    }
    
    
    /**
     * Lis annetun sarakkeen matriisin rivien phn.
     * @param sarake listtv sarake
     * @param nimi sarakkeen otsikko
     * @return onnistuiko sarakkeen lisminen
     */
    public boolean lisaaSarake(String[] sarake, String nimi) {
        return muotti.lisaaSarake(sarake, nimi);
    }
    

    /**
     * Lis annetun sarakkeen matriisiin halutulle sarakkeelle ja siirt loppuja
     * sarakkeita eteenpin.
     * @param sarake listtv sarake
     * @param minne monennenko sarakkeen paikalle laitetaan
     * @param nimi sarakkeen otsikko
     * @return onnistuiko sarakkeen lisminen
     */
    public boolean lisaaSarake(String[] sarake, int minne, String nimi) {
        return muotti.lisaaSarake(sarake, minne, nimi);
    }
    
    
    /**
     * Poistaa pyydetyn sarakkeen.
     * @param i poistettavan sarakkeen indeksi
     * @return onnistuiko sarakkeen poistaminen
     */
    public boolean poistaSarake(int i) {
        return muotti.poistaSarake(i);
    }
    
    
    /**
     * Poistaa pyydetyt sarakkeet.
     * @param alku monennestako sarakkeesta poistaminen aloitetaan
     * @param loppu monesko sarake on ensimminen, joka silytetn
     * @return onnistuiko sarakkeiden poistaminen
     */
    public boolean poistaSarakkeita(int alku, int loppu) {
        return muotti.poistaSarakkeita(alku, loppu);
    }
    
    
    
// rivien ksittely
    
    /**
     * Lis annetun mrn tyhji rivej matriisiin.
     * @param maara montako tyhj rivi halutaan
     * @return onnistuiko rivien lisminen
     */
    public boolean lisaaRiveja(int maara) {
        return muotti.lisaaRiveja(maara);
    }
    
    
    /**
     * Lis annetun mrn tyhji rivej matriisiin.
     * @param maara montako tyhj rivi halutaan
     * @param minne monennenko rivin paikalle laitetaan
     * @return onnistuiko rivien lisminen
     */
    public boolean lisaaRiveja(int maara, int minne) {
        return muotti.lisaaRiveja(maara, minne);
    }
    
    
    /**
     * Lis annetun rivin matriisin sarakkeiden phn.
     * @param rivi listtv rivi
     * @return onnistuiko rivin lisminen
     */
    public boolean lisaaRivi(String[] rivi) {
        return muotti.lisaaRivi(rivi);
    }
    
    
    /**
     * Lis annetun rivin matriisiin halutulle riville ja siirt loppuja rivej
     * eteenpin.
     * @param rivi listtv rivi
     * @param minne monennenko rivin paikalle laitetaan
     * @return onnistuiko rivin lisminen
     */
    public boolean lisaaRivi(String[] rivi, int minne) {
        return muotti.lisaaRivi(rivi, minne);
    }
    
    
    /**
     * Poistaa pyydetyn rivin.
     * @param i poistettavan rivin indeksi
     * @return onnistuiko rivin poisto
     */
    public boolean poistaRivi(int i) {
        return muotti.poistaRivi(i);
    }
    
    
    /**
     * Poistaa pyydetyt rivit.
     * @param alku monennestako rivist poistaminen aloitetaan
     * @param loppu monesko rivi on ensimminen, joka silytetn
     * @return onnistuiko rivien poisto
     */
    public boolean poistaRiveja(int alku, int loppu) {
        return muotti.poistaRiveja(alku, loppu);
    }
    
    
    /**
     * Poistaa kaikki rivit
     */
    public void clear() {
        poistaRiveja(0,getRowCount());
    }
    
// muuta
    
    /**
     * Taulukkoon laitettava muotti.
     * @param model mit taulukon sisllksi laitetaan
     */
    public void setModel(TableModelString model) {
        muotti = model;
        table.setModel(model);
    }
    
    
    /**
     * Taulukossa oleva model.
     * @return taulukon model
     */
    public TableModelString getModel() {
        return muotti;
    }
    
    
    /**
     * @return taulukon sarakkeiden mr
     */
    public int getColumnCount() {
        return muotti.getColumnCount();
    }
    
    
    /**
     * @param cc taulukon sarakkeiden mr
     */
    public void setColumnCount(int cc) {
        int oldc = muotti.getColumnCount();
        int dc = cc - oldc;
        if ( dc == 0 ) return;
        if ( dc > 0 ) lisaaSarakkeita(dc, new String[dc]);
        else poistaSarakkeita(oldc+dc, oldc);
    }
    
    
    /**
     * @return taulukon rivien mr
     */
    public int getRowCount() {
        return muotti.getRowCount();
    }

    
    /**
     * @param rc taulukon sarakkeiden mr
     */
    public void setRowCount(int rc) {
        int oldc = muotti.getColumnCount();
        int dc = rc - oldc;
        if ( dc == 0 ) return;
        if ( dc > 0 ) lisaaRiveja(rc);
        else poistaRiveja(oldc+dc, oldc);
    }
    

    /**
     * @return sisinen taulukko
     */
    public JTable getTable() {
        return table; 
    }

    /**
     * Etsii muotissa kysytyss paikassa olevan arvon ja palauttaa sen.
     * @param rivi milt rivilt etsitn
     * @param sarake mist sarakkeesta etsitn
     * @return alkion sisltm arvo
     * @throws IndexOutOfBoundsException huonot indeksit
     */
    public String haeArvo(int rivi, int sarake) throws IndexOutOfBoundsException {
        return muotti.getValueAt(rivi, sarake);
    }


    /**
     * Asettaa annetun arvon haluttuun alkioon muottiin.
     * @param arvo mik arvo alkioon asetetaan
     * @param rivi mille riville asetetaan
     * @param sarake mihin sarakkeeseen asetetaan
     * @return onnistuiko arvon asettaminen
     */
    public boolean asetaArvo(String arvo, int rivi, int sarake) {
        return muotti.asetaArvo(arvo, rivi, sarake);
    }
    
    
    /**
     * Vaihtaa pyydetyn sarakkeen otsikon halutuksi.
     * @param monesko sarakkeen indeksi
     * @param uusiOtsikko sarakkeen uusi otsikko
     * @return onnistuiko otsikon vaihto
     */
    public boolean vaihdaOtsikko(int monesko, String uusiOtsikko) {
        return muotti.vaihdaOtsikko(monesko, uusiOtsikko);
    }
    
    
    
}
