package fi.jyu.mit.gui;

/**
 * Luokka ehdotetaan luomaan niin, ett taulukkoon tulevat oliot ovat sen sisll
 * taulukossa.<br/>
 * Luokkaan on tarkoitus olla tekemtt itse muutoksia sen jlkeen kun se annetaan
 * ObjectTablen kyttn, koska muutokset tulevat rikkomaan toiminnan johtuen siit
 * etten halua vaikeuttaa rajapinnan kytt lismll siihen kuuntelijoita.
 * @author Samu Tuominen
 * @version 4.4.2011
 */
public interface TableObject {
    
    /**
     * Kertoo montako olion attribuuttia taulukkoon asetetaan. Pit toimia, vaikkei
     * sisltn olisi yhtn oliota!
     * @return attribuuttien mr
     */
    public int getAttributeCount();
    
    
    /**
     * Kertoo montako oliota listassa on.
     * @return attribuuttien mr
     */
    public int getObjectCount();
    
    
    /**
     * Kerrotaan i:nnen attribuutin tyyppi taulukolle, toistaiseksi vain "String" ,
     * "Integer" ja "Double" osaavat antaa erikoistuneen sarakkeen, muissa tapauksissa
     * sislt ksitelln "String"in. Pit toimia, vaikkei sisltn olisi yhtn
     * oliota!
     * @param i monennenko attribuutin tyyppi
     * @return attribuutin tyyppi merkkijonona
     */
    public Class<?> getClass(int i);
    
    
    /**
     * Antaa i:nnen attribuutin otsikon. Pit toimia, vaikkei sisltn olisi yhtn
     * oliota!
     * @param i monesko attribuutti
     * @return attribuutin otsikko
     */
    public String getHeader(int i);
    
    
    /**
     * Yritetn list uusi olio listaan viimeiseksi. Alusta olio ja lis se
     * oman tietorakenteesi lisksi mys tnne, taulukko hoitaa itse sen tietojen
     * asettamisen nkyville ja muutettaviksi.
     * @return onnistuiko olion lisminen
     */
    public boolean addObject();
    
    
    /**
     * Yritetn poistaa valittu olio. Muista poistaa se mys omista tietorakenteistasi,
     * jos se on tarkoituksellista.
     * @param j monettako oliota yritetn poistaa
     * @return onnistuiko poistaminen
     */
    public boolean removeObject(int j);
    
    
    /**
     * Annetaan j:nnen olion i:nnes attribuutti taulukkoon.
     * @param j monennenko olion attribuutti
     * @param i monesko attribuutti annetaan
     * @return pyydetty attribuutti
     */
    public Object getAttribute(int j, int i);

    
    
    /**
     * Yritetn asettaa taulukosta saatu arvo valitun olion attribuutiksi.
     * Muista muuttaa taulukosta haetun olion tyyppi oikeaksi.
     * @param j monennenko olion attribuutti
     * @param i monesko attribuutti
     * @param attribute asetettava arvo
     * @return onnistuiko asettaminen null=kyll, muut arvot = virhe
     */
    public String setAttribute(int j, int i, Object attribute);

}
