package fi.jyu.mit.gui.example;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;

import fi.jyu.mit.gui.ComboBoxChooser;
import fi.jyu.mit.gui.IStringListChooser;
import fi.jyu.mit.gui.ListChooser;
import fi.jyu.mit.gui.RadioButtonChooser;
import fi.jyu.mit.gui.SelectionChangeListener;
import fi.jyu.mit.gui.StringListModel;
import fi.jyu.mit.gui.Direction;

/**
 * Kokeillaan erilaisia valitsimia
 * @author vesal
 * @version 20.3.2011
 *
 */
public class ChooserExample extends JFrame {

    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    @SuppressWarnings("rawtypes")
    private final JComboBox comboBox = new JComboBox();
    private final JButton btnLisaa = new JButton("Lis\u00E4\u00E4");
    private int n = 1;
    private int clickCount = 00;
    private final JLabel labelList = new JLabel("");
    private final JLabel labelCombo = new JLabel("");
    /**
     * @wbp.nonvisual location=89,351
     */
    private final StringListModel lista = new StringListModel();
    private final JLabel labelCombo2 = new JLabel("");
    private final ListChooser list = new ListChooser();
    private final ComboBoxChooser comboBox2 = new ComboBoxChooser();
    private final RadioButtonChooser radioList = new RadioButtonChooser();
    private final JLabel labelRadio = new JLabel("");
    private final JButton buttonPoistaValinta = new JButton("Poista valinta");
    private final JButton btnPoistaAlkio = new JButton("Poista alkio");
    private final JLabel lblClickCount = new JLabel("0");

    
//    private DefaultListModel lista = new DefaultListModel();

    /**
     * Launch the application.
     * @param args ei kytss
     */
    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Throwable e) {
            e.printStackTrace();
        }
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    ChooserExample frame = new ChooserExample();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }


    /**
     * Create the frame.
     */
    @SuppressWarnings("unchecked")
    public ChooserExample() {
        radioList.getCaptionLabel().setDisplayedMnemonic('K');
        radioList.setCaption("Kukkuu");
        radioList.addSelectionChangeListener(new SelectionChangeListener<String>() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void selectionChange(IStringListChooser<String> sender) {
                labelRadio.setText(radioList.getSelectedText());
                lblClickCount.setText( "" + ++clickCount);
            }
        });
        radioList.setModel(lista);
        comboBox2.getCaptionLabel().setHorizontalAlignment(SwingConstants.CENTER);
        comboBox2.getCaptionLabel().setBorder(new EmptyBorder(0, 0, 0, 10));
        comboBox2.getCaptionLabel().setVerticalTextPosition(SwingConstants.TOP);
        comboBox2.setCaptionPosition(Direction.WEST);
        comboBox2.setModel(lista);
        list.getCaptionLabel().setHorizontalAlignment(SwingConstants.CENTER);
        list.getCaptionLabel().setDisplayedMnemonic('V');
        list.setCaptionPosition(Direction.HIDDEN);
        list.addSelectionChangeListener(new SelectionChangeListener<String>() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void selectionChange(IStringListChooser<String> sender) {
                labelList.setText(list.getSelectedText());
                lblClickCount.setText( "" + ++clickCount);
            }
        });
        list.setModel(lista);
        lista.setItems(new String[] {"kana", "koira", "mato"});
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 664, 300);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        setContentPane(contentPane);
        contentPane.setLayout(null);
        comboBox.setModel(lista);
        comboBox.addActionListener(new ActionListener() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void actionPerformed(ActionEvent e) {
                labelCombo.setText(comboBox.getSelectedItem().toString());
                lblClickCount.setText( "" + ++clickCount);
            }
        });
        comboBox.setBounds(160, 37, 105, 22);
        
        contentPane.add(comboBox);
        btnLisaa.addActionListener(new ActionListener() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void actionPerformed(ActionEvent e) {
                lista.addItem("Kana " + n++);
            }
        });
        btnLisaa.setBounds(39, 201, 88, 22);
        
        contentPane.add(btnLisaa);
        labelList.setBounds(39, 169, 88, 14);
        
        contentPane.add(labelList);
        labelCombo.setBounds(160, 169, 105, 14);
        
        contentPane.add(labelCombo);
        labelCombo2.setBounds(296, 169, 105, 14);
        
        contentPane.add(labelCombo2);
        list.setBounds(39, 37, 111, 107);
        
        contentPane.add(list);
        comboBox2.addSelectionChangeListener(new SelectionChangeListener<String>() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void selectionChange(IStringListChooser<String> sender) {
                labelCombo2.setText(comboBox2.getSelectedText());
                lblClickCount.setText( "" + ++clickCount);
            }
        });
        comboBox2.setBounds(288, 37, 113, 22);
        
        contentPane.add(comboBox2);
        radioList.setBounds(453, 21, 137, 150);
        
        contentPane.add(radioList);
        labelRadio.setBounds(453, 169, 137, 14);
        
        contentPane.add(labelRadio);
        buttonPoistaValinta.addActionListener(new ActionListener() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void actionPerformed(ActionEvent e) {
                list.clearSelection();
                comboBox2.clearSelection();
                radioList.clearSelection();
            }
        });
        buttonPoistaValinta.setBounds(152, 200, 113, 23);
        
        contentPane.add(buttonPoistaValinta);
        btnPoistaAlkio.addActionListener(new ActionListener() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void actionPerformed(ActionEvent e) {
                int i = list.getSelectedIndex();
                list.getModel().remove(i);
            }
        });
        btnPoistaAlkio.setBounds(278, 201, 123, 22);
        
        contentPane.add(btnPoistaAlkio);
        lblClickCount.setBounds(26, 11, 46, 14);
        
        contentPane.add(lblClickCount);
        // comboBox2.add(comboBox2.getCaptionLabel(),java.awt.BorderLayout.EAST);
    }
}
