package fi.jyu.mit.gui.example;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Arrays;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import fi.jyu.mit.gui.IStringListChooser;
import fi.jyu.mit.gui.ListChooser;
import fi.jyu.mit.gui.SelectionChangeListener;

/**
 * @author vesal
 * @version 10.2.2013
 */
public class MultiChooserExample extends JFrame {
    private static final long serialVersionUID = 1L;
    
    private JPanel contentPane;
    private final ListChooser listChooser = new ListChooser();
    private final JLabel lblTexts = new JLabel("");
    private final JLabel lblIdxs = new JLabel("");
    private final JLabel lblMnemonics = new JLabel("");
    private final JLabel labelSelected = new JLabel("");
    private final JButton btnValitse = new JButton("Valitse");
    private final JLabel lblTextsOrder = new JLabel("");

    /**
     * Launch the application.
     * @param args ei kytss
     */
    public static void main(String[] args) {
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    MultiChooserExample frame = new MultiChooserExample();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }

    /**
     * Create the frame.
     */
    @SuppressWarnings({ "unchecked", "rawtypes" })
    public MultiChooserExample() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 460, 339);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        setContentPane(contentPane);
        contentPane.setLayout(null);
        listChooser.setMaxChoices(3);
        listChooser.addSelectionChangeListener(new SelectionChangeListener<String>() {
            @Override
            public void selectionChange(IStringListChooser<String> sender) {
                naytaValitut();
            }
        });
        listChooser.setKohteet(new String[] {"kissa", "kana", "koira", "mato", "kettu", "kotka"});
        listChooser.setMnemonics("kaomet");
        listChooser.setBounds(143, 32, 162, 144);
        listChooser.setSelectedIndices(new int[] {2, 4, 9});
        
        contentPane.add(listChooser);
        lblTexts.setBounds(143, 247, 222, 14);
        
        contentPane.add(lblTexts);
        lblTextsOrder.setBounds(143, 272, 222, 14);
        
        contentPane.add(lblTextsOrder);
        lblIdxs.setBounds(143, 195, 222, 14);
        
        contentPane.add(lblIdxs);
        lblMnemonics.setBounds(143, 222, 222, 14);
        contentPane.add(lblMnemonics);
        labelSelected.setBounds(143, 11, 222, 14);
        
        contentPane.add(labelSelected);
        btnValitse.addActionListener(new ActionListener() {
            @Override
            @SuppressWarnings("synthetic-access")
            public void actionPerformed(ActionEvent e) {
                listChooser.setSelectedIndices(new int[]{2,3,4});
            }
        });
        btnValitse.setBounds(341, 36, 89, 23);
        
        contentPane.add(btnValitse);
    }

    /**
     * Nytetn valitut jonot
     */
    protected void naytaValitut() {
        lblTexts.setText(Arrays.toString(listChooser.getSelectedTexts()));
        lblTextsOrder.setText(Arrays.toString(listChooser.getSelectedTextsSelectionOrder()));
        lblMnemonics.setText(listChooser.getSelectedChars() + " " + listChooser.getSelectedCharsSelectionOrder());
        lblIdxs.setText(Arrays.toString(listChooser.getSelectedIndices())+ " " + Arrays.toString(listChooser.getSelectedIndicesSelectionOrder()));
        labelSelected.setText(listChooser.getSelectedIndex() + " " + listChooser.getSelectedText() + 
                             "  first: " + listChooser.getFirstSelectedIndex() + " " + listChooser.getFirstSelectedText() + 
                             "  last: " + listChooser.getLastSelectedIndex() + " " + listChooser.getLastSelectedText()); 
    }
}
