package fi.jyu.mit.gui.example;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import fi.jyu.mit.gui.ObjectTable;
import fi.jyu.mit.gui.TableObject;

/**
 *
 * @author Samu Tuominen
 * @version 18.3.2011
 */
public class ObjectTableSuunniteltuKayttotapa extends JFrame {

    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    /**
     * 
     */
    protected final ObjectTable table;
    private final JPanel panelValikot = new JPanel();
    private JButton btnPoistaValittuRivi;
    private JButton btnHaeArvo;
    private JButton btnTulostaKaikki;
    private JButton btnLisaa;


    /**
     * Launch the application.
     * @param args ei kytss
     */
    public static void main(String[] args) {
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    ObjectTableSuunniteltuKayttotapa frame = new ObjectTableSuunniteltuKayttotapa();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }


    /**
     * Create the frame.
     */
    public ObjectTableSuunniteltuKayttotapa() {
        final TableOpiskelija lista = new TableOpiskelija();
        lista.lisaa(new Opiskelija("Masi", 50, 0));
        lista.lisaa(new Opiskelija("Kessu", 34, 50));
        lista.lisaa(new Opiskelija("Aku", 1, 46));
        lista.lisaa(new Opiskelija("Iines", 2, 46));

        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 500, 300);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        contentPane.setLayout(new BorderLayout(0, 0));
        setContentPane(contentPane);

        table = new ObjectTable(lista);
        table.addRow();
        table.addRow();
        /* 
         * l tee seuraavaa oikeasti! Listty vain ett taulukon sisllss ja
         * tietorakenteessa olisi nkyv ero esimerkiss.
         * TableObjectissa ei ole kuuntelijoita sen vuoksi etten usko kaikkien
         * kumminkaan niit osaavan tehd, joten siihen ei saa itse menn tekemn
         * muutoksia sen jlkeen kun sen on ObjectTablelle antanut ellei aio
         * seuraavaksi antaa sit OBjectTablelle uudestaan.
         */
        lista.lisaa(new Opiskelija("ylimrinen rivi", 0, 0));

        contentPane.add(table, BorderLayout.CENTER);
        contentPane.add(panelValikot, BorderLayout.SOUTH);

        btnPoistaValittuRivi = new JButton("Poista valittu rivi");
        btnPoistaValittuRivi.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                table.removeSelectedRow();
            }
        });
        panelValikot.add(btnPoistaValittuRivi);

        btnHaeArvo = new JButton("Hae arvo");
        btnHaeArvo.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                JOptionPane.showMessageDialog(null,
                        table.getSelectedValue());
            }
        });
        panelValikot.add(btnHaeArvo);

        btnTulostaKaikki = new JButton("tulosta kaikki");
        btnTulostaKaikki.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                JOptionPane.showMessageDialog(null, lista.toString());
            }
        });
        panelValikot.add(btnTulostaKaikki);
        
        btnLisaa = new JButton("Lis\u00E4\u00E4");
        btnLisaa.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                table.addRow();
            }
        });
        panelValikot.add(btnLisaa);
    }


    /**
     * @author Samu Tuominen
     * @version 5.4.2011
     */
    public static class TableOpiskelija implements TableObject {

        private ArrayList<Opiskelija> lista = new ArrayList<Opiskelija>();
        Opiskelija malli = new Opiskelija();


        /**
         */
        public TableOpiskelija() {
            // alustaa luokan
        }


        /**
         * @param uusi listtv opiskelija
         */
        public void lisaa(Opiskelija uusi) {
            lista.add(uusi);
        }


        @Override
        public String toString() {
            StringBuilder arvo = new StringBuilder();
            for (int i = 0; i < lista.size(); i++) {
                arvo.append(lista.get(i).toString()).append('\n');
            }
            return arvo.toString();
        }


        @Override
        public int getAttributeCount() {
            return Opiskelija.getAttributeCount();
        }


        @Override
        public int getObjectCount() {
            return lista.size();
        }


        @Override
        public Class<?> getClass(int i) {
            return malli.getClass(i);
        }


        @Override
        public String getHeader(int i) {
            return malli.getHeader(i);
        }


        @Override
        public boolean addObject() {
            return lista.add(new Opiskelija());
        }


        @Override
        public boolean removeObject(int j) {
            try {
                lista.remove(j);
                return true;
            } catch (IndexOutOfBoundsException e) {
                return false;
            }
        }


        @Override
        public Object getAttribute(int j, int i) {
            try {
                Opiskelija valittu = lista.get(j);
                return valittu.getAttribute(i);
            } catch (IndexOutOfBoundsException e) {
                // eip tss voi mitn erityist tehd
            }
            return null;
        }


        @Override
        public String setAttribute(int j, int i, Object attribute) {
            try {
                Opiskelija valittu = lista.get(j);
                return valittu.setAttribute(i, attribute);
            } catch (IndexOutOfBoundsException e) {
                // eip tss voi mitn erityist tehd
            }
            return "Ei kentt";
        }

    }


    /**
     * @author Samu Tuominen
     * @version 5.4.2011
     */
    public static class Opiskelija {

        private String nimi;
        private int opiskelijanro;
        private double opintopisteita;


        /**
         * Luo tyhjn opiskelijan
         */
        public Opiskelija() {
            nimi = "";
        }


        /**
         * Palauttaa i:n attribuutin luokan
         * @param i monesko attribuutti
         * @return ':n attribuutin luokka
         */
        public Class<?> getClass(int i) {
            switch (i) {
                case 0:
                    return String.class;
                case 1:
                    return Integer.class;
                case 2:
                    return Double.class;
                default: // tm vain virheellist kytt varten
                    return String.class;///
            }
        }


        /**
         * Palauttaa ':n attribuutin
         * @param i monesko attribuutti
         * @return i's attribuutti
         */
        public Object getAttribute(int i) {
            switch (i) {
                case 0:
                    return getNimi();
                case 1:
                    return opiskelijanro;
                case 2:
                    return opintopisteita;
                default: // tm vain virheellist kytt varten
                    return String.class;///
            }
        }


        /**
         * Asettaa i'n attribuutin arvon
         * @param i monesko attribuutti asetetaan
         * @param attribute asetettava arvo
         * @return onnistuiko asettaminen, null = ok, muut virheilmoitus
         */
        public String setAttribute(int i, Object attribute) {
            switch (i) {
                case 0:
                    nimi = ((String)attribute);
                    return null;
                case 1:
                    opiskelijanro = ((Integer)attribute);
                    return null;
                case 2:
                    opintopisteita = ((Double)attribute);
                    return null;
                default: // tm vain virheellist kytt varten
                    return "Vr kentn indeksi";
            }
        }


        /**
         * Otsikko i:nnelle attribuutille
         * @param i monesko attribuutti otetaan
         * @return i's otsikko
         */
        public String getHeader(int i) {
            switch (i) {
                case 0:
                    return "nimi";
                case 1:
                    return "opiskelijanro";
                case 2:
                    return "opintopisteit";
                default: // tm vain virheellist kytt varten
                    return null;
            }
        }


        /**
         * @param kuka nimi
         * @param nro opiskelijanumero
         * @param pisteita opintopisteit
         */
        public Opiskelija(String kuka, int nro, double pisteita) {
            this.nimi = kuka;
            this.opiskelijanro = nro;
            this.opintopisteita = pisteita;
        }


        /**
         * @return attribuuttien mr
         */
        public static int getAttributeCount() {
            return 3;
        }


        /**
         * @return nimi opiskelijan nimi
         */
        public String getNimi() {
            return nimi;
        }


        @Override
        public String toString() {
            StringBuilder arvo = new StringBuilder();
            arvo.append(nimi).append('|');
            arvo.append(opiskelijanro).append('|');
            arvo.append(opintopisteita);
            return arvo.toString();
        }

    }

}
