package fi.jyu.mit.gui.example;

import java.awt.EventQueue;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import fi.jyu.mit.gui.IStringListChooser;
import fi.jyu.mit.gui.ListChooser;
import fi.jyu.mit.gui.SelectionChangeListener;

/**
 * Pieni esimerkki ListChooserin kytst
 * @author vesal
 * @version 20.3.2011
 */
public class SimpleListExample extends JFrame {

    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private final ListChooser list = new ListChooser();
    private final JLabel labelList = new JLabel("");


    /**
     * Launch the application.
     * @param args ei kytss
     */
    public static void main(String[] args) {
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    SimpleListExample frame = new SimpleListExample();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }


    /**
     * Create the frame.
     */
    public SimpleListExample() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 450, 300);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        setContentPane(contentPane);
        contentPane.setLayout(null);
        list.setKohteet(new String[] {"kissa", "kana", "koira"});
        list.addSelectionChangeListener(new SelectionChangeListener<String>() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void selectionChange(IStringListChooser<String> sender) {
                labelList.setText(list.getSelectedText());
            }
        });
        list.setBounds(10, 11, 260, 132);
        
        contentPane.add(list);
        labelList.setBounds(10, 192, 260, 14);
        
        contentPane.add(labelList);
    }
}
