package fi.jyu.mit.gui.example;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.StringTokenizer;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JSpinner;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.SpinnerNumberModel;
import fi.jyu.mit.gui.StringTableOld;
import fi.jyu.mit.gui.TableModelString;

/**
 *
 * @author Samu Tuominen
 * @version 18.3.2011
 */
@SuppressWarnings("rawtypes")
public class TableTest extends JFrame {
    
    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private TableModelString model;
    private final StringTableOld table = new StringTableOld();
    private final JPanel panelNappulat = new JPanel();
    private final JSpinner spinnerMista = new JSpinner();
    private final JPanel panelValikot = new JPanel();
    private final JPanel panelKayttaja = new JPanel();
    private final JLabel lblMista = new JLabel("Mist/Montako:");
    private final JLabel lblMinne = new JLabel("Minne:");
    private final JSpinner spinnerMinne = new JSpinner();
    private final JTextField tfSisalto = new JTextField("");
    private final JLabel lblSisalto = new JLabel("Sislt:");
    private final JComboBox cbLisaa = new JComboBox();
    private final JComboBox cbPoista = new JComboBox();
    private final JComboBox cbArvo = new JComboBox();
    private final JSpinner spinnerRivi = new JSpinner();
    private final JLabel lblRivi = new JLabel("Rivi:");
    private final JLabel lblSarake = new JLabel("Sarake:");
    private final JSpinner spinnerSarake = new JSpinner();
    private final JPanel panelArvo = new JPanel();
    private final JLabel lblArvo = new JLabel("Arvo:");
    private final JTextField tfArvo = new JTextField();
    private final JPanel panel = new JPanel();
    private final JPanel panel_1 = new JPanel();
    private final JPanel panelTekstit = new JPanel();
    private final JLabel lblOtsikot = new JLabel("Otsikot:");
    private final JTextField tfOtsikot = new JTextField("");

    /**
     * Launch the application.
     * @param args ei kytss
     */
    public static void main(String[] args) {
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    TableTest frame = new TableTest();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }

    /**
     * Create the frame.
     */
    @SuppressWarnings({ "boxing", "unchecked" })
    public TableTest() {
        tfOtsikot.setColumns(10);
        tfArvo.setColumns(10);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 500, 300);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        contentPane.setLayout(new BorderLayout(0, 0));
        setContentPane(contentPane);
        
        contentPane.add(table, BorderLayout.CENTER);
        model = new TableModelString(
                new String[][]
                       {{"00", "01", "02", "03", "04", "05", "06", "07", "08", "09"},
                        {"10", "11", "12", "13", "14", "15", "16", "17", "18", "19"},
                        {"20", "21", "22", "23", "24", "25", "26", "27", "28", "29"},
                        {"30", "31", "32", "33", "34", "35", "36", "37", "38", "39"},
                        {"40", "41", "42", "43", "44", "45", "46", "47", "48", "49"},
                        {"50", "51", "52", "53", "54", "55", "56", "57", "58", "59"},
                        {"60", "61", "62", "63", "64", "65", "66", "67", "68", "69"},
                        {"70", "71", "72", "73", "74", "75", "76", "77", "78", "79"},
                        {"80", "81", "82", "83", "84", "85", "86", "87", "88", "89"},
                        {"90", "91", "92", "93", "94", "95", "96", "97", "98", "99"}},
                new String[]{"0", "1", "2", "3", "4", "5", "6", "7", "8", "9"});
        table.setModel(model);
        
        table.add(panelValikot, BorderLayout.SOUTH);
        panelValikot.setLayout(new BorderLayout(0, 0));
        panelValikot.add(panelNappulat, BorderLayout.CENTER);
        cbLisaa.setModel(new DefaultComboBoxModel(
                new String[] {"Lis (sislt)",
                              "Lis sarakkeita (montako(, loppuun))",
                              "Lis sarakkeita (montako, minne)",
                              "Lis sarake (otsikot(, loppuun))",
                              "Lis sarake (otsikot, minne)",
                              "Lis rivej (montako(, loppuun))",
                              "Lis rivej (montako, minne)"}));
        cbLisaa.addActionListener(new ActionListener() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void actionPerformed(ActionEvent arg0) {
                switch (cbLisaa.getSelectedIndex()) {
                  case 0:
                      return;
                  case 1:
                      table.lisaaSarakkeita((Integer) spinnerMista.getValue(),
                                            jaaOtsikot());
                      break;
                  case 2:
                      table.lisaaSarakkeita((Integer) spinnerMista.getValue(),
                                            (Integer) spinnerMinne.getValue(),
                                            jaaOtsikot());
                      break;
                  case 3:
                      table.lisaaSarake(jaaSanat(), tfOtsikot.getText());
                      break;
                  case 4:
                      table.lisaaSarake(jaaSanat(),
                                        (Integer) spinnerMinne.getValue(),
                                        tfOtsikot.getText());
                      break;
                  case 5:
                      table.lisaaRiveja((Integer) spinnerMista.getValue());
                      break;
                  case 6:
                      table.lisaaRiveja((Integer) spinnerMista.getValue(),
                                        (Integer) spinnerMinne.getValue());
                      break;
                  default: break;    
                }
                spinnerRivi.setModel(new SpinnerNumberModel(0, 0, table.getRowCount(), 1));
                spinnerSarake.setModel(new SpinnerNumberModel(0, 0, table.getColumnCount(), 1));
            }
        });
        
        panelNappulat.add(cbLisaa);
        cbPoista.setModel(new DefaultComboBoxModel(
                new String[] {"Poista",
                              "Poista sarake (mist)",
                              "Poista sarakkeita (mist, minne)",
                              "Poista rivi (mist)",
                              "Poista rivej (mist, minne)"}));

        cbPoista.addActionListener(new ActionListener() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void actionPerformed(ActionEvent arg0) {
                switch (cbPoista.getSelectedIndex()) {
                  case 0:
                      return;
                  case 1:
                      table.poistaSarake((Integer) spinnerMista.getValue());
                      break;
                  case 2:
                      table.poistaSarakkeita((Integer) spinnerMista.getValue(),
                                             (Integer) spinnerMinne.getValue());
                      break;
                  case 3:
                      table.poistaRivi((Integer) spinnerMista.getValue());
                      break;
                  case 4:
                      table.poistaRiveja((Integer) spinnerMista.getValue(),
                                         (Integer) spinnerMinne.getValue());
                      break;
                  default:    
                }
                spinnerRivi.setModel(new SpinnerNumberModel(0, 0, table.getRowCount(), 1));
                spinnerSarake.setModel(new SpinnerNumberModel(0, 0, table.getColumnCount(), 1));
            }
        });
        panelNappulat.add(cbPoista);
        
        panelValikot.add(panel_1, BorderLayout.NORTH);
        panel_1.setLayout(new BorderLayout(0, 0));
        panel_1.add(panelKayttaja, BorderLayout.NORTH);
        
        panelKayttaja.add(lblMista);
        panelKayttaja.add(spinnerMista);
        spinnerMista.setModel(new SpinnerNumberModel(0, 0, null, 1));
        
        panelKayttaja.add(lblMinne);
        panelKayttaja.add(spinnerMinne);
        spinnerMinne.setModel(new SpinnerNumberModel(0, 0, null, 1));
        
        panel_1.add(panelTekstit, BorderLayout.SOUTH);
        
        panelTekstit.add(lblOtsikot);
        
        panelTekstit.add(tfOtsikot);
        panelTekstit.add(lblSisalto);
        panelTekstit.add(tfSisalto);
        tfSisalto.setColumns(15);
        
        table.add(panel, BorderLayout.EAST);
        
        contentPane.add(panelArvo, BorderLayout.SOUTH);
        cbArvo.setModel(new DefaultComboBoxModel(
                new String[] {"Arvo",
                              "Aseta arvo",
                              "Hae arvo",
                              "Vaihda otsikko (sarake, otsikot)"}));
        cbArvo.addActionListener(new ActionListener() {
            @SuppressWarnings("synthetic-access")
            @Override
            public void actionPerformed(ActionEvent arg0) {
                switch (cbArvo.getSelectedIndex()) {
                  case 0:
                      return;
                  case 1:
                      table.asetaArvo(tfArvo.getText(),
                                      (Integer) spinnerRivi.getValue(),
                                      (Integer) spinnerSarake.getValue());
                      break;
                  case 2:
                      String arvo = table.haeArvo((Integer) spinnerRivi.getValue(),
                                                  (Integer) spinnerSarake.getValue());
                      JOptionPane.showMessageDialog(null, arvo);
                      break;
                  case 3:
                      table.vaihdaOtsikko((Integer) spinnerSarake.getValue(),
                                          tfOtsikot.getText());
                      break;
                  default:    
                }
            }
        });
        panelArvo.add(cbArvo);
        panelArvo.add(lblRivi);
        panelArvo.add(spinnerRivi);
        spinnerRivi.setModel(new SpinnerNumberModel(0, 0, table.getRowCount(), 1));
        panelArvo.add(lblSarake);
        panelArvo.add(spinnerSarake);
        spinnerSarake.setModel(new SpinnerNumberModel(0, 0, table.getColumnCount(), 1));
        
        panelArvo.add(lblArvo);
        
        panelArvo.add(tfArvo);
    }
    
    
    private String[] jaaSanat() {
        StringTokenizer jakaja = new StringTokenizer(tfSisalto.getText(), ",");
        ArrayList<String> sanat = new ArrayList<String>();
        while (jakaja.hasMoreTokens()) {
            sanat.add(jakaja.nextToken());
        }
        return sanat.toArray(new String[sanat.size()]);
    }
    
    
    private String[] jaaOtsikot() {
        StringTokenizer jakaja = new StringTokenizer(tfOtsikot.getText(), ",");
        ArrayList<String> sanat = new ArrayList<String>();
        while (jakaja.hasMoreTokens()) {
            sanat.add(jakaja.nextToken());
        }
        return sanat.toArray(new String[sanat.size()]);
    }

}
